import { DatabaseConfig, DatabaseAction } from '../../../types/database';
import { ClassId } from '../../../types/class';
export interface DatabaseResult {
    id: ClassId;
    rows: object[];
}
export default class DatabaseClient {
    /**
     * Private propreties
     */
    private connectionConfigs;
    private poolCluster;
    private logger;
    private persistent;
    /**
     * Constructor
     * @param {Object} config
     */
    constructor({ uris, persistent, logger }: DatabaseConfig);
    /**
     * Extract database configuration from URI
     * @param {Object} config
     */
    private extractConfig;
    escape(value: any): string;
    escapeKey(value: string, useRaw?: boolean): string;
    initialize(): Promise<void>;
    private connect;
    query(queryString: string, action: DatabaseAction): Promise<DatabaseResult>;
}
