"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var mysql_1 = __importDefault(require("mysql"));
var parse_url_1 = __importDefault(require("parse-url"));
var enforce_js_1 = __importDefault(require("enforce-js"));
var error_1 = __importDefault(require("../../../utils/error"));
var constants_1 = require("../../../utils/constants");
var chalk_1 = __importDefault(require("chalk"));
var DatabaseClient = /** @class */ (function () {
    /**
     * Constructor
     * @param {Object} config
     */
    function DatabaseClient(_a) {
        var e_1, _b;
        var uris = _a.uris, persistent = _a.persistent, logger = _a.logger;
        /**
         * Private propreties
         */
        this.connectionConfigs = { write: [], read: [] };
        try {
            // Get connection configs
            for (var uris_1 = __values(uris), uris_1_1 = uris_1.next(); !uris_1_1.done; uris_1_1 = uris_1.next()) {
                var uriConfig = uris_1_1.value;
                // Check if action is write
                if (uriConfig.action === constants_1.DatabaseWrite) {
                    this.connectionConfigs.write.push(this.extractConfig(uriConfig.uri));
                }
                else if (uriConfig.action === constants_1.DatabaseRead) {
                    this.connectionConfigs.read.push(this.extractConfig(uriConfig.uri));
                }
                else
                    throw new error_1.default(error_1.default.Code.ForbiddenOperation, "Database action must either be 'write' or 'read'");
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (uris_1_1 && !uris_1_1.done && (_b = uris_1.return)) _b.call(uris_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        // Set connection settings
        this.persistent = persistent;
        this.logger = logger;
    }
    /**
     * Extract database configuration from URI
     * @param {Object} config
     */
    DatabaseClient.prototype.extractConfig = function (uri) {
        var parsedURI = parse_url_1.default(uri);
        var identity = parsedURI.user.split(':');
        // Get params
        var params = parsedURI.query;
        var config = __assign({ protocol: parsedURI.protocol, host: parsedURI.resource, port: parsedURI.port, user: decodeURIComponent(identity[0]), password: decodeURIComponent(identity[1]), database: parsedURI.pathname.slice(1) }, params);
        // Enforce
        enforce_js_1.default(templateObject_1 || (templateObject_1 = __makeTemplateObject(["", " as a string"], ["", " as a string"])), { protocol: config.protocol });
        enforce_js_1.default(templateObject_2 || (templateObject_2 = __makeTemplateObject(["", " as a string"], ["", " as a string"])), { host: config.host });
        enforce_js_1.default(templateObject_3 || (templateObject_3 = __makeTemplateObject(["", " as a number"], ["", " as a number"])), { port: config.port });
        enforce_js_1.default(templateObject_4 || (templateObject_4 = __makeTemplateObject(["", " as a string"], ["", " as a string"])), { user: config.user });
        enforce_js_1.default(templateObject_5 || (templateObject_5 = __makeTemplateObject(["", " as a string"], ["", " as a string"])), { password: config.password });
        enforce_js_1.default(templateObject_6 || (templateObject_6 = __makeTemplateObject(["", " as a string"], ["", " as a string"])), { database: config.database });
        return config;
    };
    DatabaseClient.prototype.escape = function (value) {
        // Escape keys
        return mysql_1.default.escape(value);
    };
    DatabaseClient.prototype.escapeKey = function (value, useRaw) {
        if (useRaw === void 0) { useRaw = false; }
        if (useRaw) {
            value = mysql_1.default.escapeId(value.replace('.', '$'));
            return value.replace('$', '.');
        }
        return mysql_1.default.escapeId(value, useRaw);
    };
    DatabaseClient.prototype.initialize = function () {
        return __awaiter(this, void 0, void 0, function () {
            var e_2, _a, e_3, _b, index, _c, _d, writeConfig, _e, _f, readConfig, result, rows;
            return __generator(this, function (_g) {
                switch (_g.label) {
                    case 0:
                        // If pool is already initialized, skip
                        if (this.poolCluster)
                            return [2 /*return*/];
                        // Prepare pool cluster
                        this.poolCluster = mysql_1.default.createPoolCluster();
                        index = 0;
                        try {
                            for (_c = __values(this.connectionConfigs.write), _d = _c.next(); !_d.done; _d = _c.next()) {
                                writeConfig = _d.value;
                                this.poolCluster.add("" + constants_1.DatabaseWrite.toUpperCase() + ++index, writeConfig);
                            }
                        }
                        catch (e_2_1) { e_2 = { error: e_2_1 }; }
                        finally {
                            try {
                                if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
                            }
                            finally { if (e_2) throw e_2.error; }
                        }
                        // Loop through read connections
                        index = 0;
                        try {
                            for (_e = __values(this.connectionConfigs.read), _f = _e.next(); !_f.done; _f = _e.next()) {
                                readConfig = _f.value;
                                this.poolCluster.add("" + constants_1.DatabaseRead.toUpperCase() + ++index, readConfig);
                            }
                        }
                        catch (e_3_1) { e_3 = { error: e_3_1 }; }
                        finally {
                            try {
                                if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
                            }
                            finally { if (e_3) throw e_3.error; }
                        }
                        return [4 /*yield*/, this.query('SELECT 1+1 AS result', constants_1.DatabaseRead)];
                    case 1:
                        result = _g.sent();
                        try {
                            rows = result['rows'] || [{ result: undefined }];
                            if (rows[0]['result'] === 2)
                                return [2 /*return*/];
                            else
                                throw new error_1.default(error_1.default.Code.InternalServerError, 'Could not connect to the pool');
                        }
                        catch (err) {
                            throw new error_1.default(error_1.default.Code.InternalServerError, 'Could not connect to the pool');
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    DatabaseClient.prototype.connect = function (action) {
        if (action === void 0) { action = constants_1.DatabaseWrite; }
        return __awaiter(this, void 0, void 0, function () {
            var onConnect, err_1;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        onConnect = new Promise(function (resolve, reject) {
                            _this.poolCluster.getConnection(action.toUpperCase() + "*", function (err, connection) {
                                if (err)
                                    return reject(err);
                                resolve(connection);
                            });
                        });
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, onConnect];
                    case 2: 
                    // Await on the connection
                    return [2 /*return*/, _a.sent()];
                    case 3:
                        err_1 = _a.sent();
                        // Throw errors for disconnections
                        throw new error_1.default(error_1.default.Code.InternalServerError, "Could not connect to the database: " + err_1.message);
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    DatabaseClient.prototype.query = function (queryString, action) {
        return __awaiter(this, void 0, void 0, function () {
            var connection, onQuery, rows, result, err_2;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.connect(action)];
                    case 1:
                        connection = _a.sent();
                        onQuery = new Promise(function (resolve, reject) {
                            // Display query
                            _this.logger.info(chalk_1.default.green(queryString));
                            // Run the query
                            connection.query(queryString, function (err, result) {
                                if (err)
                                    return reject(err);
                                resolve(result);
                            });
                        });
                        _a.label = 2;
                    case 2:
                        _a.trys.push([2, 4, , 5]);
                        return [4 /*yield*/, onQuery];
                    case 3:
                        rows = _a.sent();
                        // Release or destroy the connection
                        if (this.persistent)
                            connection.release();
                        else
                            connection.destroy();
                        result = void 0;
                        if (rows instanceof Array)
                            result = { rows: rows };
                        else
                            result = { id: rows['insertId'] };
                        return [2 /*return*/, result];
                    case 4:
                        err_2 = _a.sent();
                        throw new error_1.default(error_1.default.Code.DatabaseError, "Invalid query request: " + err_2.message + ", " + queryString);
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    return DatabaseClient;
}());
exports.default = DatabaseClient;
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5, templateObject_6;
//# sourceMappingURL=client.js.map