"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var client_1 = __importDefault(require("./client"));
var error_1 = __importDefault(require("../../../utils/error"));
var key_map_1 = __importDefault(require("../../../utils/key-map"));
var constants_1 = require("../../../utils/constants");
var constraint_map_1 = require("../../../utils/constraint-map");
var format_1 = require("../../../utils/format");
var compound_key_1 = __importDefault(require("../../../utils/compound-key"));
var relation_1 = __importDefault(require("../../../features/orm/relation"));
var specials_1 = require("../../../features/orm/specials");
var version = require('../../../package.json').version;
var MySQLDatabaseAdapter = /** @class */ (function () {
    /**
     * Constructor
     * @param {Object} config
     */
    function MySQLDatabaseAdapter(config) {
        var _a;
        var _this = this;
        this.constraints = (_a = {},
            _a[constraint_map_1.Constraints.EqualTo] = function (k, v) { return k + " = " + _this.regularEscape(v); },
            _a[constraint_map_1.Constraints.NotEqualTo] = function (k, v) { return k + " <> " + _this.regularEscape(v); },
            _a[constraint_map_1.Constraints.GreaterThan] = function (k, v) { return k + " > " + _this.regularEscape(v); },
            _a[constraint_map_1.Constraints.GreaterThanOrEqualTo] = function (k, v) { return k + " >= " + _this.regularEscape(v); },
            _a[constraint_map_1.Constraints.LessThan] = function (k, v) { return k + " < " + _this.regularEscape(v); },
            _a[constraint_map_1.Constraints.LessThanOrEqualTo] = function (k, v) { return k + " <= " + _this.regularEscape(v); },
            _a[constraint_map_1.Constraints.Exists] = function (k, v) { return k + " " + (v ? 'IS NOT NULL' : 'IS NULL'); },
            _a[constraint_map_1.Constraints.ContainedIn] = function (k, v) { return k + " IN (" + _this.collectionEscape(v) + ")"; },
            _a[constraint_map_1.Constraints.NotContainedIn] = function (k, v) { return k + " NOT IN (" + _this.collectionEscape(v) + ")"; },
            _a[constraint_map_1.Constraints.ContainedInOrDoesNotExist] = function (k, v) { return "(" + k + " IS NULL OR " + k + " IN (" + _this.collectionEscape(v) + "))"; },
            _a[constraint_map_1.Constraints.StartsWith] = function (k, v) { return k + " LIKE " + _this.regularEscape(v + "%"); },
            _a[constraint_map_1.Constraints.EndsWith] = function (k, v) { return k + " LIKE " + _this.regularEscape("%" + v); },
            _a[constraint_map_1.Constraints.Contains] = function (k, v) { return k + " LIKE " + _this.regularEscape("%" + v + "%"); },
            _a[constraint_map_1.Constraints.ContainsEither] = function (k, v) { return "(" + v.map(function (i) { return k + " LIKE " + _this.regularEscape("%" + i + "%"); }).join(' OR ') + ")"; },
            _a[constraint_map_1.Constraints.ContainsAll] = function (k, v) { return "(" + v.map(function (i) { return k + " LIKE " + _this.regularEscape("%" + i + "%"); }).join(' AND ') + ")"; },
            _a[constraint_map_1.Constraints.FoundIn] = function (k, v) { return k + " IN (" + _this.subqueryEscape(v) + ")"; },
            _a[constraint_map_1.Constraints.FoundInEither] = function (k, v) { return "(" + v.map(function (i) { return k + " IN (" + _this.subqueryEscape(i) + ")"; }).join(' OR ') + ")"; },
            _a[constraint_map_1.Constraints.FoundInAll] = function (k, v) { return "(" + v.map(function (i) { return k + " IN (" + _this.subqueryEscape(i) + ")"; }).join(' AND ') + ")"; },
            _a[constraint_map_1.Constraints.NotFoundIn] = function (k, v) { return k + " NOT IN (" + _this.subqueryEscape(v) + ")"; },
            _a[constraint_map_1.Constraints.NotFoundInEither] = function (k, v) { return "(" + v.map(function (i) { return k + " NOT IN (" + _this.subqueryEscape(i) + ")"; }).join(' AND ') + ")"; },
            _a);
        this.regularEscape = function (value) {
            // Set escape methods for special types
            if (value instanceof specials_1.Increment) {
                value.escapeKey = _this.client.escapeKey;
                value.escape = _this.client.escape;
            }
            if (value instanceof specials_1.JsonAction) {
                value.escapeKey = _this.client.escapeKey;
                value.escape = _this.client.escape;
            }
            // Return escaped value
            return _this.client.escape(value);
        };
        this.collectionEscape = function (value) {
            return value.map(function (item) { return _this.regularEscape(item); }).join(', ');
        };
        this.subqueryEscape = function (query) {
            // Get query keys
            var _a = query.toQueryOptions(), source = _a.source, columns = _a.columns, relations = _a.relations, constraints = _a.constraints;
            return _this.getFindClause({ source: source, columns: columns, relations: relations, constraints: constraints });
        };
        // Prepare parameters
        this.client = new client_1.default(config);
    }
    Object.defineProperty(MySQLDatabaseAdapter.prototype, "currentTimestamp", {
        /**
         * Get current timesamp
         * @returns {String}
         */
        get: function () {
            return format_1.toDatabaseDate(new Date().toISOString());
        },
        enumerable: true,
        configurable: true
    });
    MySQLDatabaseAdapter.prototype.initialize = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: 
                    // Initialize the client
                    return [4 /*yield*/, this.client.initialize()];
                    case 1:
                        // Initialize the client
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    MySQLDatabaseAdapter.prototype.escapeKey = function (key, useRaw) {
        var _this = this;
        if (useRaw === void 0) { useRaw = false; }
        return compound_key_1.default.isUsedBy(key) ?
            // If key is a compound key, use concat
            "CONCAT(" + compound_key_1.default.from(key).map(function (k) { return _this.client.escapeKey(k); }) + ")"
            // Else, do a simple escape
            : this.client.escapeKey(key, useRaw);
    };
    MySQLDatabaseAdapter.prototype.parseConstraint = function (key, constraint, value) {
        // Escape key
        var escapedKey = this.escapeKey(key);
        // Check if constraint exists
        if (typeof this.constraints[constraint] !== 'undefined') {
            // Return constraint
            return this.constraints[constraint](escapedKey, value);
        }
        // Else, throw an error
        throw new error_1.default(error_1.default.Code.ForbiddenOperation, "Constraint not found: " + constraint);
    };
    /**
     * Generate Find Statement
     * @description Decoupled from the `find` method
     * in order to allow subquery select statements
     * @param {String} source
     * @param {String} className
     * @param {Array} select
     * @param {Array} relations
     * @param {KeyMap} where
     * @param {boolean} isSubquery
     */
    MySQLDatabaseAdapter.prototype.getFindClause = function (_a) {
        var _this = this;
        var source = _a.source, columns = _a.columns, relations = _a.relations, constraints = _a.constraints;
        var e_1, _b, e_2, _c;
        // Get select
        var select = [];
        try {
            for (var _d = __values(columns.entries()), _e = _d.next(); !_e.done; _e = _d.next()) {
                var _f = __read(_e.value, 2), key = _f[0], alias = _f[1];
                select.push(this.escapeKey(key) + " AS " + this.escapeKey(alias, true));
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_e && !_e.done && (_b = _d.return)) _b.call(_d);
            }
            finally { if (e_1) throw e_1.error; }
        }
        // Get from
        var from = this.escapeKey(source[0]) + " AS " + this.escapeKey(source[1]);
        // Get joins
        var joins = [];
        try {
            for (var _g = __values(relations.entries()), _h = _g.next(); !_h.done; _h = _g.next()) {
                var _j = __read(_h.value, 2), alias = _j[0], relation = _j[1];
                joins.push("LEFT OUTER JOIN " + this.escapeKey(relation.class.source) + " AS " + this.escapeKey(alias, true)
                    + (" ON " + this.escapeKey(relation.parentClassKey()) + " = " + this.escapeKey(relation.sourceClassKey(source[1]))));
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (_h && !_h.done && (_c = _g.return)) _c.call(_g);
            }
            finally { if (e_2) throw e_2.error; }
        }
        // Get where
        var where = constraints.toArray()
            .reduce(function (list, keyConstraints) { return __spread(list, keyConstraints.constraints); }, [])
            .map(function (_a) {
            var key = _a.key, constraint = _a.constraint, value = _a.value;
            return _this.parseConstraint(key, constraint, value);
        });
        // Prepare clause
        var findClause = "SELECT " + select.join(', ') + " FROM " + from + " " + joins.join('\n') + " WHERE " + where.join(' AND ');
        return findClause;
    };
    /**
     * Generate Sorting
     * @param {String} className
     * @param {Array} sort
     */
    MySQLDatabaseAdapter.prototype.getSortClause = function (className, sort) {
        var _this = this;
        // Return sorting string
        return sort.map(function (keySort) {
            // If it starts with a hyphen, sort by descending order
            // Otherwise, sort by ascending order
            if (keySort[0] === constants_1.SortSymbol)
                return _this.escapeKey(keySort.slice(1)) + " DESC";
            else
                return _this.escapeKey(keySort) + " ASC";
        }).join(', ');
    };
    /**
     * Map row keys into appropriate relations
     * @param {Object} row
     */
    MySQLDatabaseAdapter.prototype.mapRows = function (row) {
        var e_3, _a, _b;
        // Prepare key map
        var keys = new key_map_1.default;
        try {
            // Iterate through the row's keys
            for (var _c = __values(Object.entries(row)), _d = _c.next(); !_d.done; _d = _c.next()) {
                var _e = __read(_d.value, 2), key = _e[0], value = _e[1];
                // If key is for a relation
                if (relation_1.default.isUsedBy(key)) {
                    // Prepare relation parameters
                    var _f = __read(relation_1.default.parseKey(key), 2), relationName = _f[0], relationKey = _f[1];
                    // Assign relation
                    var relation = __assign({}, keys.get(relationName), (_b = {}, _b[relationKey] = value, _b));
                    // Set key to the latest value
                    keys.set(relationName, relation);
                }
                else {
                    // Set the key value
                    keys.set(key, row[key]);
                }
            }
        }
        catch (e_3_1) { e_3 = { error: e_3_1 }; }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
            }
            finally { if (e_3) throw e_3.error; }
        }
        // Return the key map
        return keys;
    };
    MySQLDatabaseAdapter.prototype.find = function (source, columns, relations, constraints, sorting, skipped, limitation) {
        return __awaiter(this, void 0, void 0, function () {
            var e_4, _a, findClause, sortingClause, selectScript, result, rows, _b, _c, row, item;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        findClause = this.getFindClause({ source: source, columns: columns, relations: relations, constraints: constraints });
                        sortingClause = this.getSortClause(source[1], sorting);
                        selectScript = findClause + " ORDER BY " + sortingClause + " LIMIT " + skipped + ", " + limitation + "; -- Warp Server " + version;
                        return [4 /*yield*/, this.client.query(selectScript, constants_1.DatabaseRead)];
                    case 1:
                        result = _d.sent();
                        rows = [];
                        try {
                            for (_b = __values(result.rows), _c = _b.next(); !_c.done; _c = _b.next()) {
                                row = _c.value;
                                item = this.mapRows(row);
                                rows.push(item);
                            }
                        }
                        catch (e_4_1) { e_4 = { error: e_4_1 }; }
                        finally {
                            try {
                                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                            }
                            finally { if (e_4) throw e_4.error; }
                        }
                        // Return result as an array of KeyMaps
                        return [2 /*return*/, rows];
                }
            });
        });
    };
    MySQLDatabaseAdapter.prototype.create = function (source, keys) {
        return __awaiter(this, void 0, void 0, function () {
            var now, sqlInputKeys, sqlInputValues, createScript, result;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        now = this.currentTimestamp;
                        keys.set(constants_1.CreatedAt, now);
                        keys.set(constants_1.UpdatedAt, now);
                        sqlInputKeys = keys.keys.map(function (key) { return _this.client.escapeKey(key); });
                        sqlInputValues = keys.values.map(function (value) { return _this.client.escape(value); });
                        createScript = "INSERT INTO " + this.client.escapeKey(source) + " (" + sqlInputKeys.join(', ') + ") "
                            + ("VALUES (" + sqlInputValues.join(', ') + "); -- Warp Server " + version);
                        return [4 /*yield*/, this.client.query(createScript, constants_1.DatabaseWrite)];
                    case 1:
                        result = _a.sent();
                        // Return the id
                        return [2 /*return*/, result.id];
                }
            });
        });
    };
    MySQLDatabaseAdapter.prototype.update = function (source, keys, id) {
        return __awaiter(this, void 0, void 0, function () {
            var idKey, now, sqlInput, updateScript;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        idKey = this.client.escapeKey(constants_1.InternalId);
                        now = this.currentTimestamp;
                        keys.set(constants_1.UpdatedAt, now);
                        sqlInput = keys.toArray().reduce(function (input, _a) {
                            var _b = __read(_a, 2), key = _b[0], value = _b[1];
                            return (__spread(input, [
                                _this.client.escapeKey(key) + " = " + _this.client.escape(value),
                            ]));
                        }, []);
                        updateScript = "UPDATE " + this.client.escapeKey(source) + " SET " + sqlInput.join(', ') + " WHERE " + idKey + " = " + id + "; -- Warp Server " + version;
                        // Update the item
                        return [4 /*yield*/, this.client.query(updateScript, constants_1.DatabaseWrite)];
                    case 1:
                        // Update the item
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    MySQLDatabaseAdapter.prototype.destroy = function (source, keys, id) {
        return __awaiter(this, void 0, void 0, function () {
            var idKey, now, sqlInput, destroyScript;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        idKey = this.client.escapeKey(constants_1.InternalId);
                        now = this.currentTimestamp;
                        keys.set(constants_1.UpdatedAt, now);
                        keys.set(constants_1.DeletedAt, now);
                        sqlInput = keys.toArray().reduce(function (input, _a) {
                            var _b = __read(_a, 2), key = _b[0], value = _b[1];
                            return (__spread(input, [
                                _this.client.escapeKey(key) + " = " + _this.client.escape(value),
                            ]));
                        }, []);
                        destroyScript = "UPDATE " + this.client.escapeKey(source) + " SET " + sqlInput.join(', ') + " WHERE " + idKey + " = " + id + "; -- Warp Server " + version;
                        // Update the item
                        return [4 /*yield*/, this.client.query(destroyScript, constants_1.DatabaseWrite)];
                    case 1:
                        // Update the item
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    return MySQLDatabaseAdapter;
}());
exports.default = MySQLDatabaseAdapter;
//# sourceMappingURL=index.js.map