"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var error_1 = __importDefault(require("../../utils/error"));
var console_1 = __importDefault(require("./console"));
var Logger = /** @class */ (function () {
    function Logger() {
    }
    /**
     * Static use
     */
    Logger.use = function (channel, name, level) {
        // Get log channel
        var logChannel = this.Channels[channel];
        // Check if logger exists
        if (typeof logChannel === 'undefined')
            throw new error_1.default(error_1.default.Code.MissingConfiguration, "Logger `" + channel + "` is not supported");
        else {
            var logger = new logChannel(name);
            logger.level = level;
            return logger;
        }
    };
    Logger.Channels = Object.freeze({
        console: console_1.default,
    });
    return Logger;
}());
exports.default = Logger;
//# sourceMappingURL=index.js.map