import Warp from '../index';
import Class from '../features/orm/class';
import Collection from '../utils/collection';
import { GetOptionsType, FindOptionsType, CreateOptionsType, UpdateOptionsType, DestroyOptionsType } from '../types/classes';
export default class ClassController {
    private api;
    constructor(api: Warp);
    find({ user, className, select, include, where, sort, skip, limit }: FindOptionsType): Promise<Collection<Class>>;
    get({ user, className, id, include, select }: GetOptionsType): Promise<Class>;
    create({ user, className, keys }: CreateOptionsType): Promise<Class>;
    update({ user, className, keys, id }: UpdateOptionsType): Promise<Class>;
    destroy({ user, className, id }: DestroyOptionsType): Promise<Class>;
}
