"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var error_1 = __importDefault(require("../utils/error"));
var query_1 = __importDefault(require("../features/orm/query"));
var constants_1 = require("../utils/constants");
var ClassController = /** @class */ (function () {
    function ClassController(api) {
        this.api = api;
    }
    ClassController.prototype.find = function (_a) {
        var user = _a.user, className = _a.className, select = _a.select, include = _a.include, _b = _a.where, where = _b === void 0 ? {} : _b, sort = _a.sort, skip = _a.skip, limit = _a.limit;
        return __awaiter(this, void 0, void 0, function () {
            var classType, query, classCollection;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        classType = this.api.classes.get(className);
                        query = new query_1.default(classType);
                        // Set options
                        if (typeof select !== 'undefined')
                            query.select(select);
                        if (typeof include !== 'undefined')
                            query.include(include);
                        if (typeof sort !== 'undefined')
                            query.sortBy(sort);
                        if (typeof skip !== 'undefined')
                            query.skip(skip);
                        if (typeof limit !== 'undefined')
                            query.limit(limit);
                        if (typeof where !== 'undefined')
                            query.where(where);
                        return [4 /*yield*/, this.api.classes.find(query, { user: user || undefined })];
                    case 1:
                        classCollection = _c.sent();
                        // Return collection
                        return [2 /*return*/, classCollection];
                }
            });
        });
    };
    ClassController.prototype.get = function (_a) {
        var user = _a.user, className = _a.className, id = _a.id, include = _a.include, select = _a.select;
        return __awaiter(this, void 0, void 0, function () {
            var classType, classInstance;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        classType = this.api.classes.get(className);
                        return [4 /*yield*/, this.api.classes.getById(classType, id, include, select, { user: user || undefined })];
                    case 1:
                        classInstance = _b.sent();
                        // Check if class is found
                        if (classInstance === null)
                            throw new error_1.default(error_1.default.Code.ForbiddenOperation, "Object `" + classType.className + "` with id `" + id + "` not found");
                        // Return the class
                        return [2 /*return*/, classInstance];
                }
            });
        });
    };
    ClassController.prototype.create = function (_a) {
        var user = _a.user, className = _a.className, _b = _a.keys, keys = _b === void 0 ? {} : _b;
        return __awaiter(this, void 0, void 0, function () {
            var classType, classInstance;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        classType = this.api.classes.get(className);
                        // Check if id was sent in keys
                        if (typeof keys[constants_1.InternalId] === 'undefined')
                            throw new error_1.default(error_1.default.Code.ForbiddenOperation, 'Cannot manually set the `id` key on creation');
                        classInstance = new classType(keys);
                        // Save the instance
                        return [4 /*yield*/, this.api.classes.save(classInstance, { user: user || undefined })];
                    case 1:
                        // Save the instance
                        _c.sent();
                        // Return the class
                        return [2 /*return*/, classInstance];
                }
            });
        });
    };
    ClassController.prototype.update = function (_a) {
        var user = _a.user, className = _a.className, _b = _a.keys, keys = _b === void 0 ? {} : _b, id = _a.id;
        return __awaiter(this, void 0, void 0, function () {
            var classType, classInstance;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        classType = this.api.classes.get(className);
                        classInstance = new classType(__assign({}, keys, { id: id }));
                        // Save the instance
                        return [4 /*yield*/, this.api.classes.save(classInstance, { user: user || undefined })];
                    case 1:
                        // Save the instance
                        _c.sent();
                        // Return the class
                        return [2 /*return*/, classInstance];
                }
            });
        });
    };
    ClassController.prototype.destroy = function (_a) {
        var user = _a.user, className = _a.className, id = _a.id;
        return __awaiter(this, void 0, void 0, function () {
            var classType, classInstance;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        classType = this.api.classes.get(className);
                        classInstance = new classType(id);
                        // Destroy the instance
                        return [4 /*yield*/, this.api.classes.destroy(classInstance, { user: user || undefined })];
                    case 1:
                        // Destroy the instance
                        _b.sent();
                        // Return the class
                        return [2 /*return*/, classInstance];
                }
            });
        });
    };
    return ClassController;
}());
exports.default = ClassController;
//# sourceMappingURL=class.js.map