import Class from '../orm/class';
import Query from '../orm/query';
import { ClassManager } from '../..';
import { ClassOptions } from '../../types/class';
export default class User extends Class {
    username: string;
    email: string;
    password: string;
    private isCurrentUser;
    private isMaster;
    private hasAccess;
    verifyFindAccess<Q extends Query<any>, U extends User | undefined>(query: Q, opts: ClassOptions<U>): void;
    verifyGetAccess<Q extends Query<any>, U extends User | undefined>(query: Q, opts: ClassOptions<U>): any;
    validateCredentials<U extends User | undefined>(classes: ClassManager, opts: ClassOptions<U>): Promise<void>;
    verifyUpdateAccess<U extends User | undefined>(classes: ClassManager, opts: ClassOptions<U>): void;
    verifyDestroyAccess<U extends User | undefined>(classes: any, opts: ClassOptions<U>): void;
}
