"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var class_1 = __importStar(require("../orm/class"));
var key_1 = require("../orm/keys/key");
var error_1 = __importDefault(require("../../utils/error"));
var query_1 = __importDefault(require("../orm/query"));
var constants_1 = require("../../utils/constants");
var __1 = require("../..");
var triggers_1 = require("../orm/keys/modifiers/triggers");
var hidden_1 = require("../orm/keys/modifiers/hidden");
var User = /** @class */ (function (_super) {
    __extends(User, _super);
    function User() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    User_1 = User;
    User.prototype.isCurrentUser = function (user) {
        return typeof user !== 'undefined' && user.id === this.id;
    };
    User.prototype.isMaster = function (master) {
        return typeof master === 'boolean' && master;
    };
    User.prototype.hasAccess = function (user, master) {
        return this.isCurrentUser(user) || this.isMaster(master);
    };
    User.prototype.verifyFindAccess = function (query, opts) {
        // Get opts
        var master = opts.master;
        // If user does not have access
        if (!this.isMaster(master))
            throw new error_1.default(error_1.default.Code.ForbiddenOperation, 'Finding users can only be done by the master');
    };
    User.prototype.verifyGetAccess = function (query, opts) {
        // Get opts
        var user = opts.user, master = opts.master;
        // If user is master
        if (this.isMaster)
            return query;
        else if (!this.hasAccess(user, master)) {
            if (user)
                query.equalTo(constants_1.InternalId, user.id);
            else
                throw new error_1.default(error_1.default.Code.ForbiddenOperation, 'You cannot anonymously fetch user data unless you are a master');
        }
    };
    User.prototype.validateCredentials = function (classes, opts) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, _b, usernameQuery, emailQuery, matchQuery, match;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        if (!this.isNew) return [3 /*break*/, 2];
                        usernameQuery = new query_1.default(User_1)
                            .equalTo(constants_1.InternalKeys.Auth.Username, this.username);
                        emailQuery = new query_1.default(User_1)
                            .equalTo(constants_1.InternalKeys.Auth.Email, this.email);
                        matchQuery = new query_1.default(User_1)
                            .foundInEither(constants_1.InternalId, [
                            (_a = {}, _a[constants_1.InternalId] = usernameQuery, _a),
                            (_b = {}, _b[constants_1.InternalId] = emailQuery, _b),
                        ]);
                        return [4 /*yield*/, classes.first(matchQuery)];
                    case 1:
                        match = _c.sent();
                        // Check if match exists
                        if (match !== null) {
                            if (match.username === this.username)
                                throw new error_1.default(error_1.default.Code.UsernameTaken, 'Username already taken');
                            else if (match.email === this.email)
                                throw new error_1.default(error_1.default.Code.EmailTaken, 'Email already taken');
                        }
                        _c.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    User.prototype.verifyUpdateAccess = function (classes, opts) {
        // Get opts
        var user = opts.user, master = opts.master;
        // If user does not have access
        if (!this.isNew && !this.hasAccess(user, master)) {
            throw new error_1.default(error_1.default.Code.ForbiddenOperation, 'You cannot edit the data of another user unless you are a master');
        }
    };
    User.prototype.verifyDestroyAccess = function (classes, opts) {
        // Get opts
        var user = opts.user, master = opts.master;
        // If user does not have access
        if (!this.hasAccess(user, master)) {
            throw new error_1.default(error_1.default.Code.ForbiddenOperation, 'You cannot remove the data of another user unless you are a master');
        }
    };
    var User_1, _a, _b;
    __decorate([
        key_1.key,
        __metadata("design:type", String)
    ], User.prototype, "username", void 0);
    __decorate([
        key_1.key,
        __metadata("design:type", String)
    ], User.prototype, "email", void 0);
    __decorate([
        hidden_1.hidden, key_1.key,
        __metadata("design:type", String)
    ], User.prototype, "password", void 0);
    __decorate([
        triggers_1.beforeFind,
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [typeof (_a = typeof Q !== "undefined" && Q) === "function" ? _a : Object, Object]),
        __metadata("design:returntype", void 0)
    ], User.prototype, "verifyFindAccess", null);
    __decorate([
        triggers_1.beforeGet,
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [typeof (_b = typeof Q !== "undefined" && Q) === "function" ? _b : Object, Object]),
        __metadata("design:returntype", Object)
    ], User.prototype, "verifyGetAccess", null);
    __decorate([
        triggers_1.beforeSave,
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [__1.ClassManager, Object]),
        __metadata("design:returntype", Promise)
    ], User.prototype, "validateCredentials", null);
    __decorate([
        triggers_1.beforeSave,
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [__1.ClassManager, Object]),
        __metadata("design:returntype", void 0)
    ], User.prototype, "verifyUpdateAccess", null);
    __decorate([
        triggers_1.beforeDestroy,
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object, Object]),
        __metadata("design:returntype", void 0)
    ], User.prototype, "verifyDestroyAccess", null);
    User = User_1 = __decorate([
        class_1.define
    ], User);
    return User;
}(class_1.default));
exports.default = User;
//# sourceMappingURL=user.js.map