import { FunctionMapType, FunctionOptions } from '../../types/functions';
import Function from './function';
import User from '../auth/user';
export default class FunctionManager {
    private functions;
    /**
     * Register functions to actions mapper
     * @param actionMap
     */
    register(functionMap: FunctionMapType<any>): void;
    /**
     * Get function from registry
     * @param functionName
     */
    get<F extends typeof Function>(functionName: string): F;
    /**
     * Run the function
     * @param functionType
     */
    run<F extends typeof Function, U extends User | undefined>(functionType: F, keys: {
        [name: string]: any;
    }, opts?: FunctionOptions<U>): Promise<any>;
}
