"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var enforce_js_1 = __importDefault(require("enforce-js"));
var function_1 = __importDefault(require("./function"));
var error_1 = __importDefault(require("../../utils/error"));
var FunctionManager = /** @class */ (function () {
    function FunctionManager() {
        this.functions = {};
    }
    /**
     * Register functions to actions mapper
     * @param actionMap
     */
    FunctionManager.prototype.register = function (functionMap) {
        var e_1, _a, _b;
        try {
            // Iterate through class map
            for (var _c = __values(Object.entries(functionMap)), _d = _c.next(); !_d.done; _d = _c.next()) {
                var _e = __read(_d.value, 2), functionName = _e[0], functionType = _e[1];
                // Make a sample instance
                var sampleInstance = new functionType;
                // Check data type
                enforce_js_1.default(templateObject_1 || (templateObject_1 = __makeTemplateObject(["", " as a ", ""], ["", " as a ", ""])), (_b = {}, _b[functionName] = sampleInstance, _b), { Function: function_1.default });
                // Get function name
                var functionClassName = functionType.name;
                // Add to functions
                this.functions[functionType.functionName || functionClassName] = functionType;
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
            }
            finally { if (e_1) throw e_1.error; }
        }
    };
    /**
     * Get function from registry
     * @param functionName
     */
    FunctionManager.prototype.get = function (functionName) {
        // Get function
        var functionType = this.functions[functionName];
        // Check if class exists
        if (typeof functionType === 'undefined')
            throw new error_1.default(error_1.default.Code.FunctionNotFound, "Function '" + functionName + "' has not been registered");
        // Return class
        return functionType;
    };
    /**
     * Run the function
     * @param functionType
     */
    FunctionManager.prototype.run = function (functionType, keys, opts) {
        return __awaiter(this, void 0, void 0, function () {
            var functionInstance;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        functionInstance = new functionType(keys, opts && opts.user);
                        // Check if user has access
                        if (functionInstance.statics().masterOnly && !(opts && opts.master))
                            throw new error_1.default(error_1.default.Code.ForbiddenOperation, 'This function can only be accessed by a master');
                        return [4 /*yield*/, functionInstance.run(keys, opts)];
                    case 1: 
                    // Run function
                    return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    return FunctionManager;
}());
exports.default = FunctionManager;
var templateObject_1;
//# sourceMappingURL=function-manager.js.map