"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var format_1 = require("../../utils/format");
var key_map_1 = __importDefault(require("../../utils/key-map"));
var FunctionClass = /** @class */ (function () {
    function FunctionClass(keys, user) {
        if (keys === void 0) { keys = {}; }
        this.keys = new key_map_1.default();
        // Check if current user is provided
        if (typeof user !== 'undefined' && user !== null)
            this.user = user;
        // Iterate through each param
        if (typeof keys !== 'undefined') {
            for (var key in keys) {
                // Get value
                var value = keys[key];
                // Check if setter exists
                var keyDescriptor = Object.getOwnPropertyDescriptor(this.constructor.prototype, format_1.toCamelCase(key));
                if (keyDescriptor && typeof keyDescriptor.set === 'function') {
                    var setter = keyDescriptor.set.bind(this);
                    setter(value);
                }
                else
                    this.set(key, value);
            }
        }
        // After setting values, make the key map immutable
        this.keys.freeze();
    }
    FunctionClass.prototype.statics = function () {
        return this.constructor;
    };
    // @deprecated
    FunctionClass.prototype.set = function (key, value) {
        this.keys.set(key, value);
    };
    // @deprecated
    FunctionClass.prototype.get = function (key) {
        return this.keys.get(key);
    };
    Object.defineProperty(FunctionClass.prototype, "currentUser", {
        get: function () {
            return this.user;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FunctionClass, "functionName", {
        get: function () {
            return;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FunctionClass, "masterOnly", {
        get: function () {
            return false;
        },
        enumerable: true,
        configurable: true
    });
    FunctionClass.prototype.run = function (params, opts) {
        return;
    };
    return FunctionClass;
}());
exports.default = FunctionClass;
//# sourceMappingURL=function.js.map