"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var enforce_js_1 = __importDefault(require("enforce-js"));
var class_1 = __importStar(require("./class"));
var query_1 = __importDefault(require("./query"));
var collection_1 = __importDefault(require("../../utils/collection"));
var error_1 = __importDefault(require("../../utils/error"));
var constants_1 = require("../../utils/constants");
var key_map_1 = __importDefault(require("../../utils/key-map"));
var ClassManager = /** @class */ (function () {
    function ClassManager(database) {
        this.classes = {};
        this.database = database;
    }
    /**
     * Get key map from instance
     * @param classInstance
     */
    ClassManager.prototype.getKeyMapFrom = function (classInstance) {
        // Get definition
        var definition = class_1.ClassDefinitionManager.get(classInstance.statics());
        // Get class keys
        var classKeys = classInstance.keys;
        // Set keys to save
        var keys = classKeys.toArray().reduce(function (keyMap, keyValue) {
            // Get key map
            var _a = __read(keyValue, 2), key = _a[0], value = _a[1];
            // Get relation definition
            var relationDefinition = definition.relations[key];
            // Check if relation definition exists
            if (typeof relationDefinition !== 'undefined') {
                // Get key source
                var keySource = relationDefinition.toRelation().sourceKey;
                // Set key value
                keyMap.set(keySource, value.id);
            }
            else
                keyMap.set(key, value);
            // Return key map
            return keyMap;
        }, new key_map_1.default);
        // Return keys
        return keys;
    };
    /**
     * Connect to the database
     */
    ClassManager.prototype.initialize = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.database.initialize()];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    /**
     * Register classes to data mapper
     * @param classMap
     */
    ClassManager.prototype.register = function (classMap) {
        var e_1, _a, _b;
        try {
            // Iterate through class map
            for (var _c = __values(Object.entries(classMap)), _d = _c.next(); !_d.done; _d = _c.next()) {
                var _e = __read(_d.value, 2), className = _e[0], classType = _e[1];
                // Make a sample instance
                var sampleInstance = new classType;
                // Check data type
                enforce_js_1.default(templateObject_1 || (templateObject_1 = __makeTemplateObject(["", " as a ", ""], ["", " as a ", ""])), (_b = {}, _b[className] = sampleInstance, _b), { Class: class_1.default });
                // Add to classes
                this.classes[classType.className] = classType;
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
            }
            finally { if (e_1) throw e_1.error; }
        }
    };
    /**
     * Get class from registry
     * @param className
     */
    ClassManager.prototype.get = function (className) {
        // Get class
        var classType = this.classes[className];
        // Check if class exists
        if (typeof classType === 'undefined')
            throw new error_1.default(error_1.default.Code.ClassNotFound, "Class '" + className + "' has not been registered");
        // Return class
        return classType;
    };
    /**
     * Find objects
     * @param query
     * @param opts
     */
    ClassManager.prototype.find = function (query, opts) {
        if (opts === void 0) { opts = {}; }
        return __awaiter(this, void 0, void 0, function () {
            var e_2, _a, e_3, _b, classInstance, definition, beforeFindTriggers, beforeFindTriggers_1, beforeFindTriggers_1_1, trigger, e_2_1, _c, source, columns, relations, constraints, sorting, skipped, limitation, result, rows, result_1, result_1_1, row;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        // Validate instance
                        enforce_js_1.default(templateObject_2 || (templateObject_2 = __makeTemplateObject(["", " as a ", ""], ["", " as a ", ""])), { QueryToFind: query }, { Query: query_1.default });
                        classInstance = new query.class;
                        definition = class_1.ClassDefinitionManager.get(classInstance.statics());
                        beforeFindTriggers = definition.triggers.filter(function (trigger) { return trigger.type === constants_1.TriggerBeforeFind; });
                        _d.label = 1;
                    case 1:
                        _d.trys.push([1, 6, 7, 8]);
                        beforeFindTriggers_1 = __values(beforeFindTriggers), beforeFindTriggers_1_1 = beforeFindTriggers_1.next();
                        _d.label = 2;
                    case 2:
                        if (!!beforeFindTriggers_1_1.done) return [3 /*break*/, 5];
                        trigger = beforeFindTriggers_1_1.value;
                        return [4 /*yield*/, trigger.action.apply(classInstance, [query, opts])];
                    case 3:
                        _d.sent();
                        _d.label = 4;
                    case 4:
                        beforeFindTriggers_1_1 = beforeFindTriggers_1.next();
                        return [3 /*break*/, 2];
                    case 5: return [3 /*break*/, 8];
                    case 6:
                        e_2_1 = _d.sent();
                        e_2 = { error: e_2_1 };
                        return [3 /*break*/, 8];
                    case 7:
                        try {
                            if (beforeFindTriggers_1_1 && !beforeFindTriggers_1_1.done && (_a = beforeFindTriggers_1.return)) _a.call(beforeFindTriggers_1);
                        }
                        finally { if (e_2) throw e_2.error; }
                        return [7 /*endfinally*/];
                    case 8:
                        _c = query.toQueryOptions(), source = _c.source, columns = _c.columns, relations = _c.relations, constraints = _c.constraints, sorting = _c.sorting, skipped = _c.skipped, limitation = _c.limitation;
                        return [4 /*yield*/, this.database.find(source, columns, relations, constraints, sorting, skipped, limitation)];
                    case 9:
                        result = _d.sent();
                        rows = [];
                        try {
                            for (result_1 = __values(result), result_1_1 = result_1.next(); !result_1_1.done; result_1_1 = result_1.next()) {
                                row = result_1_1.value;
                                // Push the row
                                rows.push(query.getClassFromKeys(row));
                            }
                        }
                        catch (e_3_1) { e_3 = { error: e_3_1 }; }
                        finally {
                            try {
                                if (result_1_1 && !result_1_1.done && (_b = result_1.return)) _b.call(result_1);
                            }
                            finally { if (e_3) throw e_3.error; }
                        }
                        // Return the result
                        return [2 /*return*/, new collection_1.default(rows)];
                }
            });
        });
    };
    /**
     * Find the first object that matches
     * @param query
     * @param opts
     */
    ClassManager.prototype.first = function (query, opts) {
        if (opts === void 0) { opts = {}; }
        return __awaiter(this, void 0, void 0, function () {
            var e_4, _a, classInstance, definition, beforeFirstTriggers, beforeFirstTriggers_1, beforeFirstTriggers_1_1, trigger, e_4_1, result;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        // Validate instance
                        enforce_js_1.default(templateObject_3 || (templateObject_3 = __makeTemplateObject(["", " as a ", ""], ["", " as a ", ""])), { QueryToFindFirst: query }, { Query: query_1.default });
                        // Limit to first item
                        query.limit(1);
                        classInstance = new query.class;
                        definition = class_1.ClassDefinitionManager.get(classInstance.statics());
                        beforeFirstTriggers = definition.triggers.filter(function (trigger) { return trigger.type === constants_1.TriggerBeforeFirst; });
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 6, 7, 8]);
                        beforeFirstTriggers_1 = __values(beforeFirstTriggers), beforeFirstTriggers_1_1 = beforeFirstTriggers_1.next();
                        _b.label = 2;
                    case 2:
                        if (!!beforeFirstTriggers_1_1.done) return [3 /*break*/, 5];
                        trigger = beforeFirstTriggers_1_1.value;
                        return [4 /*yield*/, trigger.action.apply(classInstance, [query, opts])];
                    case 3:
                        _b.sent();
                        _b.label = 4;
                    case 4:
                        beforeFirstTriggers_1_1 = beforeFirstTriggers_1.next();
                        return [3 /*break*/, 2];
                    case 5: return [3 /*break*/, 8];
                    case 6:
                        e_4_1 = _b.sent();
                        e_4 = { error: e_4_1 };
                        return [3 /*break*/, 8];
                    case 7:
                        try {
                            if (beforeFirstTriggers_1_1 && !beforeFirstTriggers_1_1.done && (_a = beforeFirstTriggers_1.return)) _a.call(beforeFirstTriggers_1);
                        }
                        finally { if (e_4) throw e_4.error; }
                        return [7 /*endfinally*/];
                    case 8: return [4 /*yield*/, this.find(query, opts)];
                    case 9:
                        result = _b.sent();
                        // If collection is empty, return null
                        if (result.count() === 0)
                            return [2 /*return*/, null];
                        else
                            return [2 /*return*/, result.first()];
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Find a single object
     * @param classType
     * @param {number|string} id
     */
    ClassManager.prototype.getById = function (classType, id, include, select, opts) {
        if (opts === void 0) { opts = {}; }
        return __awaiter(this, void 0, void 0, function () {
            var e_5, _a, classInstance, query, definition, beforeGetTriggers, beforeGetTriggers_1, beforeGetTriggers_1_1, trigger, e_5_1, _b, source, columns, relations, constraints, sorting, skipped, limitation, result;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        classInstance = new classType;
                        enforce_js_1.default(templateObject_4 || (templateObject_4 = __makeTemplateObject(["", " as a ", ""], ["", " as a ", ""])), { ClassToGet: classInstance }, { Class: class_1.default });
                        query = new query_1.default(classType)
                            .equalTo(constants_1.InternalId, id)
                            .skip(0)
                            .limit(1);
                        if (typeof select !== 'undefined')
                            query.select(select);
                        if (typeof include !== 'undefined')
                            query.include(include);
                        definition = class_1.ClassDefinitionManager.get(classInstance.statics());
                        beforeGetTriggers = definition.triggers.filter(function (trigger) { return trigger.type === constants_1.TriggerBeforeGet; });
                        _c.label = 1;
                    case 1:
                        _c.trys.push([1, 6, 7, 8]);
                        beforeGetTriggers_1 = __values(beforeGetTriggers), beforeGetTriggers_1_1 = beforeGetTriggers_1.next();
                        _c.label = 2;
                    case 2:
                        if (!!beforeGetTriggers_1_1.done) return [3 /*break*/, 5];
                        trigger = beforeGetTriggers_1_1.value;
                        return [4 /*yield*/, trigger.action.apply(classInstance, [query, opts])];
                    case 3:
                        _c.sent();
                        _c.label = 4;
                    case 4:
                        beforeGetTriggers_1_1 = beforeGetTriggers_1.next();
                        return [3 /*break*/, 2];
                    case 5: return [3 /*break*/, 8];
                    case 6:
                        e_5_1 = _c.sent();
                        e_5 = { error: e_5_1 };
                        return [3 /*break*/, 8];
                    case 7:
                        try {
                            if (beforeGetTriggers_1_1 && !beforeGetTriggers_1_1.done && (_a = beforeGetTriggers_1.return)) _a.call(beforeGetTriggers_1);
                        }
                        finally { if (e_5) throw e_5.error; }
                        return [7 /*endfinally*/];
                    case 8:
                        _b = query.toQueryOptions(), source = _b.source, columns = _b.columns, relations = _b.relations, constraints = _b.constraints, sorting = _b.sorting, skipped = _b.skipped, limitation = _b.limitation;
                        return [4 /*yield*/, this.database.find(source, columns, relations, constraints, sorting, skipped, limitation)];
                    case 9:
                        result = _c.sent();
                        // Return empty result if null
                        if (!result)
                            return [2 /*return*/, null];
                        // Return result
                        return [2 /*return*/, query.getClassFromKeys(result[0])];
                }
            });
        });
    };
    /**
     * Save the object
     * @param classInstance
     */
    ClassManager.prototype.save = function (classInstance, opts) {
        if (opts === void 0) { opts = {}; }
        return __awaiter(this, void 0, void 0, function () {
            var e_6, _a, definition, beforeSaveTriggers, beforeSaveTriggers_1, beforeSaveTriggers_1_1, trigger, e_6_1, keys, identifier, _b, afterSaveTriggers;
            var _this = this;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        // Validate instance
                        enforce_js_1.default(templateObject_5 || (templateObject_5 = __makeTemplateObject(["", " as a ", ""], ["", " as a ", ""])), { ClassToSave: classInstance }, { Class: class_1.default });
                        definition = class_1.ClassDefinitionManager.get(classInstance.statics());
                        beforeSaveTriggers = definition.triggers.filter(function (trigger) { return trigger.type === constants_1.TriggerBeforeSave; });
                        _c.label = 1;
                    case 1:
                        _c.trys.push([1, 6, 7, 8]);
                        beforeSaveTriggers_1 = __values(beforeSaveTriggers), beforeSaveTriggers_1_1 = beforeSaveTriggers_1.next();
                        _c.label = 2;
                    case 2:
                        if (!!beforeSaveTriggers_1_1.done) return [3 /*break*/, 5];
                        trigger = beforeSaveTriggers_1_1.value;
                        return [4 /*yield*/, trigger.action.apply(classInstance, [this, opts])];
                    case 3:
                        _c.sent();
                        _c.label = 4;
                    case 4:
                        beforeSaveTriggers_1_1 = beforeSaveTriggers_1.next();
                        return [3 /*break*/, 2];
                    case 5: return [3 /*break*/, 8];
                    case 6:
                        e_6_1 = _c.sent();
                        e_6 = { error: e_6_1 };
                        return [3 /*break*/, 8];
                    case 7:
                        try {
                            if (beforeSaveTriggers_1_1 && !beforeSaveTriggers_1_1.done && (_a = beforeSaveTriggers_1.return)) _a.call(beforeSaveTriggers_1);
                        }
                        finally { if (e_6) throw e_6.error; }
                        return [7 /*endfinally*/];
                    case 8:
                        keys = this.getKeyMapFrom(classInstance);
                        identifier = classInstance.newIdentifier;
                        // Set identifier inside keys if it exists
                        if (typeof identifier !== 'undefined')
                            keys.set(constants_1.InternalId, identifier);
                        if (!classInstance.isNew) return [3 /*break*/, 10];
                        // Execute create query and retrieve the new id
                        _b = classInstance;
                        return [4 /*yield*/, this.database.create(classInstance.statics().className, keys)];
                    case 9:
                        // Execute create query and retrieve the new id
                        _b.identifier = _c.sent();
                        return [3 /*break*/, 12];
                    case 10: 
                    // Execute update query
                    return [4 /*yield*/, this.database.update(classInstance.statics().className, keys, classInstance.id)];
                    case 11:
                        // Execute update query
                        _c.sent();
                        _c.label = 12;
                    case 12:
                        // Set identifier if it exists
                        if (typeof identifier !== 'undefined')
                            classInstance.identifier = identifier;
                        // Clear temp identifier
                        classInstance.newIdentifier = undefined;
                        afterSaveTriggers = definition.triggers.filter(function (trigger) { return trigger.type === constants_1.TriggerAfterSave; });
                        (function () { return __awaiter(_this, void 0, void 0, function () {
                            var e_7, _a, afterSaveTriggers_1, afterSaveTriggers_1_1, trigger, e_7_1, err_1;
                            return __generator(this, function (_b) {
                                switch (_b.label) {
                                    case 0:
                                        _b.trys.push([0, 9, , 10]);
                                        _b.label = 1;
                                    case 1:
                                        _b.trys.push([1, 6, 7, 8]);
                                        afterSaveTriggers_1 = __values(afterSaveTriggers), afterSaveTriggers_1_1 = afterSaveTriggers_1.next();
                                        _b.label = 2;
                                    case 2:
                                        if (!!afterSaveTriggers_1_1.done) return [3 /*break*/, 5];
                                        trigger = afterSaveTriggers_1_1.value;
                                        return [4 /*yield*/, trigger.action.apply(classInstance, [this, opts])];
                                    case 3:
                                        _b.sent();
                                        _b.label = 4;
                                    case 4:
                                        afterSaveTriggers_1_1 = afterSaveTriggers_1.next();
                                        return [3 /*break*/, 2];
                                    case 5: return [3 /*break*/, 8];
                                    case 6:
                                        e_7_1 = _b.sent();
                                        e_7 = { error: e_7_1 };
                                        return [3 /*break*/, 8];
                                    case 7:
                                        try {
                                            if (afterSaveTriggers_1_1 && !afterSaveTriggers_1_1.done && (_a = afterSaveTriggers_1.return)) _a.call(afterSaveTriggers_1);
                                        }
                                        finally { if (e_7) throw e_7.error; }
                                        return [7 /*endfinally*/];
                                    case 8: return [3 /*break*/, 10];
                                    case 9:
                                        err_1 = _b.sent();
                                        return [3 /*break*/, 10];
                                    case 10: return [2 /*return*/];
                                }
                            });
                        }); })();
                        // Return immediately
                        return [2 /*return*/, classInstance];
                }
            });
        });
    };
    /**
     * Destroy the object
     * @param classInstance
     */
    ClassManager.prototype.destroy = function (classInstance, opts) {
        if (opts === void 0) { opts = {}; }
        return __awaiter(this, void 0, void 0, function () {
            var e_8, _a, definition, beforeDestroyTriggers, beforeDestroyTriggers_1, beforeDestroyTriggers_1_1, trigger, e_8_1, keys, afterDestroyTriggers;
            var _this = this;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        // Validate instance
                        enforce_js_1.default(templateObject_6 || (templateObject_6 = __makeTemplateObject(["", " as a ", ""], ["", " as a ", ""])), { ClassToDestroy: classInstance }, { Class: class_1.default });
                        definition = class_1.ClassDefinitionManager.get(classInstance.statics());
                        beforeDestroyTriggers = definition.triggers.filter(function (trigger) { return trigger.type === constants_1.TriggerBeforeDestroy; });
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 6, 7, 8]);
                        beforeDestroyTriggers_1 = __values(beforeDestroyTriggers), beforeDestroyTriggers_1_1 = beforeDestroyTriggers_1.next();
                        _b.label = 2;
                    case 2:
                        if (!!beforeDestroyTriggers_1_1.done) return [3 /*break*/, 5];
                        trigger = beforeDestroyTriggers_1_1.value;
                        return [4 /*yield*/, trigger.action.apply(classInstance, [this, opts])];
                    case 3:
                        _b.sent();
                        _b.label = 4;
                    case 4:
                        beforeDestroyTriggers_1_1 = beforeDestroyTriggers_1.next();
                        return [3 /*break*/, 2];
                    case 5: return [3 /*break*/, 8];
                    case 6:
                        e_8_1 = _b.sent();
                        e_8 = { error: e_8_1 };
                        return [3 /*break*/, 8];
                    case 7:
                        try {
                            if (beforeDestroyTriggers_1_1 && !beforeDestroyTriggers_1_1.done && (_a = beforeDestroyTriggers_1.return)) _a.call(beforeDestroyTriggers_1);
                        }
                        finally { if (e_8) throw e_8.error; }
                        return [7 /*endfinally*/];
                    case 8:
                        keys = this.getKeyMapFrom(classInstance);
                        // Execute destroy query
                        return [4 /*yield*/, this.database.destroy(classInstance.statics().className, keys, classInstance.id)];
                    case 9:
                        // Execute destroy query
                        _b.sent();
                        afterDestroyTriggers = definition.triggers.filter(function (trigger) { return trigger.type === constants_1.TriggerAfterDestroy; });
                        (function () { return __awaiter(_this, void 0, void 0, function () {
                            var e_9, _a, afterDestroyTriggers_1, afterDestroyTriggers_1_1, trigger, e_9_1, err_2;
                            return __generator(this, function (_b) {
                                switch (_b.label) {
                                    case 0:
                                        _b.trys.push([0, 9, , 10]);
                                        _b.label = 1;
                                    case 1:
                                        _b.trys.push([1, 6, 7, 8]);
                                        afterDestroyTriggers_1 = __values(afterDestroyTriggers), afterDestroyTriggers_1_1 = afterDestroyTriggers_1.next();
                                        _b.label = 2;
                                    case 2:
                                        if (!!afterDestroyTriggers_1_1.done) return [3 /*break*/, 5];
                                        trigger = afterDestroyTriggers_1_1.value;
                                        return [4 /*yield*/, trigger.action.apply(classInstance, [this, opts])];
                                    case 3:
                                        _b.sent();
                                        _b.label = 4;
                                    case 4:
                                        afterDestroyTriggers_1_1 = afterDestroyTriggers_1.next();
                                        return [3 /*break*/, 2];
                                    case 5: return [3 /*break*/, 8];
                                    case 6:
                                        e_9_1 = _b.sent();
                                        e_9 = { error: e_9_1 };
                                        return [3 /*break*/, 8];
                                    case 7:
                                        try {
                                            if (afterDestroyTriggers_1_1 && !afterDestroyTriggers_1_1.done && (_a = afterDestroyTriggers_1.return)) _a.call(afterDestroyTriggers_1);
                                        }
                                        finally { if (e_9) throw e_9.error; }
                                        return [7 /*endfinally*/];
                                    case 8: return [3 /*break*/, 10];
                                    case 9:
                                        err_2 = _b.sent();
                                        return [3 /*break*/, 10];
                                    case 10: return [2 /*return*/];
                                }
                            });
                        }); })();
                        // Return immediately
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Generates a batch loader function
     * Compatible with the `dataloader` library of Facebook
     * @param query
     */
    ClassManager.prototype.batch = function (query, opts) {
        var _this = this;
        return function (ids) { return __awaiter(_this, void 0, void 0, function () {
            var results, resultsMap, orderedResults;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        // Contained in
                        query.containedIn(constants_1.InternalId, ids);
                        return [4 /*yield*/, this.find(query, opts)];
                    case 1:
                        results = _a.sent();
                        resultsMap = results.toMap();
                        orderedResults = ids.map(function (id) { return resultsMap.get(id) || null; });
                        return [2 /*return*/, orderedResults];
                }
            });
        }); };
    };
    return ClassManager;
}());
exports.default = ClassManager;
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5, templateObject_6;
//# sourceMappingURL=class-manager.js.map