"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var error_1 = __importDefault(require("../../utils/error"));
var key_map_1 = __importDefault(require("../../utils/key-map"));
var format_1 = require("../../utils/format");
var constants_1 = require("../../utils/constants");
var relation_1 = __importStar(require("./relation"));
var compound_key_1 = __importDefault(require("../../utils/compound-key"));
var date_1 = __importDefault(require("./keys/types/date"));
var specials_1 = require("./specials");
exports.ClassDefinitionSymbol = Symbol.for('warp-server:class-definition');
var DefaultClassDefinition = {
    keys: [],
    timestamps: Object.values(constants_1.InternalTimestamps),
    relations: {},
    triggers: [],
    hidden: [],
    guarded: [],
    computed: [],
};
var ClassDefinitionManager = /** @class */ (function () {
    function ClassDefinitionManager() {
    }
    // Resolved issue with: https://github.com/rbuckton/reflect-metadata/issues/53#issuecomment-274906502
    ClassDefinitionManager.get = function (classType) {
        // Get definition
        var definition = Reflect.getMetadata(exports.ClassDefinitionSymbol, classType) || DefaultClassDefinition;
        // Get immutable copy of class definition
        return {
            keys: definition.keys.slice(),
            timestamps: definition.timestamps.slice(),
            relations: __assign({}, definition.relations),
            triggers: definition.triggers.slice(),
            hidden: definition.hidden.slice(),
            guarded: definition.guarded.slice(),
            computed: definition.computed.slice(),
        };
    };
    ClassDefinitionManager.set = function (classType, definition) {
        Reflect.defineMetadata(exports.ClassDefinitionSymbol, definition, classType);
    };
    return ClassDefinitionManager;
}());
exports.ClassDefinitionManager = ClassDefinitionManager;
/**
 * Extend Class with className and source
 */
var ClassDecorator = function (opts) {
    // Get options
    var className = opts.className, source = opts.source;
    // Return decorator
    return function (constructor) {
        // Define class
        var DefinedClass = /** @class */ (function (_super) {
            __extends(DefinedClass, _super);
            function DefinedClass() {
                return _super !== null && _super.apply(this, arguments) || this;
            }
            Object.defineProperty(DefinedClass, "className", {
                get: function () {
                    return className || format_1.toSnakeCase(constructor.name);
                },
                enumerable: true,
                configurable: true
            });
            Object.defineProperty(DefinedClass, "source", {
                get: function () {
                    return source || this.className;
                },
                enumerable: true,
                configurable: true
            });
            return DefinedClass;
        }(constructor));
        // Return defined class
        return DefinedClass;
    };
};
function define() {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    if (typeof args[0] !== 'object') {
        var className = format_1.toSnakeCase(args[0].name);
        return ClassDecorator({ className: className })(args[0]);
    }
    else {
        return ClassDecorator(args[0]);
    }
}
exports.define = define;
/**
 * Class
 */
var Class = /** @class */ (function () {
    /**
     * Constructor
     * @param {Object} params
     * @param {Number} id
     */
    function Class(keys) {
        var e_1, _a;
        if (keys === void 0) { keys = {}; }
        this.keys = new key_map_1.default;
        // Get definition
        var definition = ClassDefinitionManager.get(this.statics());
        // If 'keys' is an id, set the id
        if (typeof keys === 'number') {
            this.identifier = keys;
        }
        else if (typeof keys === 'object') {
            try {
                // Iterate through each param
                for (var _b = __values(Object.entries(keys)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var _d = __read(_c.value, 2), key = _d[0], value = _d[1];
                    // Check if key exists
                    if (!this.statics().has(key))
                        throw new error_1.default(error_1.default.Code.ForbiddenOperation, "Key `" + key + "` does not exist in '" + this.statics().className + "'");
                    // If the key is an id, set the id
                    // Else, set the value
                    if (key === constants_1.InternalId)
                        this.identifier = value;
                    else if (definition.guarded.includes(key))
                        throw new error_1.default(error_1.default.Code.ForbiddenOperation, "Key `" + key + "` of `" + this.statics().className + "` cannot be mass assigned because it is guarded");
                    else if (definition.computed.includes(key))
                        throw new error_1.default(error_1.default.Code.ForbiddenOperation, "Key `" + key + "` of `" + this.statics().className + "` cannot be mass assigned because it is computed");
                    else
                        this[format_1.toCamelCase(key)] = value;
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_1) throw e_1.error; }
            }
        }
        else
            throw new error_1.default(error_1.default.Code.ForbiddenOperation, "`keys` must be an object or an id");
    }
    Object.defineProperty(Class, "className", {
        get: function () {
            throw new error_1.default(error_1.default.Code.MissingConfiguration, 'Classes extended from `Class` must define a static getter for className');
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Class, "source", {
        get: function () {
            return this.className;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @description Check if provided key exists for the class
     * @param {String} key
     */
    Class.has = function (key) {
        var _this = this;
        // Class definition
        var definition = ClassDefinitionManager.get(this);
        // Check if the key is compound
        if (compound_key_1.default.isUsedBy(key)) {
            return compound_key_1.default.from(key).every(function (k) { return _this.has(k); });
        }
        else if (relation_1.default.isUsedBy(key) && this.hasRelationKey(key))
            return true;
        else if (key === constants_1.InternalId)
            return true;
        else if (definition.timestamps.includes(key))
            return true;
        else if (definition.keys.includes(key))
            return true;
        else
            return false;
    };
    Class.hasRelationKey = function (key) {
        // Check if key parts are valid
        if (!relation_1.default.isValid(key))
            return false;
        // Get source
        var _a = __read(relation_1.default.parseKey(key), 2), sourceClassName = _a[0], sourceKey = _a[1];
        // Get class relation
        var definition = ClassDefinitionManager.get(this);
        var relationDefinition = definition.relations[sourceClassName];
        // Check if relation exists
        if (!(relationDefinition instanceof relation_1.RelationDefinition)) {
            return false;
        }
        else {
            // Check if relation has the key
            var relation = relationDefinition.toRelation();
            if (!relation.class.has(sourceKey)) {
                return false;
            }
        }
        return true;
    };
    Class.withId = function (id) {
        return new this(id);
    };
    Class.prototype.statics = function () {
        return this.constructor;
    };
    Object.defineProperty(Class.prototype, "isNew", {
        get: function () {
            return typeof this.identifier === 'undefined';
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Class.prototype, "id", {
        get: function () {
            return this.identifier;
        },
        set: function (value) {
            throw new error_1.default(error_1.default.Code.ForbiddenOperation, 'Cannot manually set the `id` key');
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Class.prototype, "createdAt", {
        get: function () {
            var keyManager = date_1.default(constants_1.CreatedAt);
            return keyManager.getter(this.keys.get(keyManager.name));
        },
        set: function (value) {
            throw new error_1.default(error_1.default.Code.ForbiddenOperation, 'Cannot manually set the `createdAt` key');
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Class.prototype, "updatedAt", {
        get: function () {
            var keyManager = date_1.default(constants_1.UpdatedAt);
            return keyManager.getter(this.keys.get(keyManager.name));
        },
        set: function (value) {
            throw new error_1.default(error_1.default.Code.ForbiddenOperation, 'Cannot manually set the `updatedAt` key');
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Class.prototype, "deletedAt", {
        set: function (value) {
            throw new error_1.default(error_1.default.Code.ForbiddenOperation, 'Cannot manually set the `deletedAt` key');
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Set `id` for new objects
     * @param id
     */
    Class.prototype.setNewId = function (id) {
        this.newIdentifier = id;
    };
    /**
     * Increment the value of a numeric key
     * @param classInstance
     * @param key
     * @param value
     */
    Class.prototype.increment = function (key, value) {
        // Check if key exists
        if (!this.statics().has(key))
            throw new error_1.default(error_1.default.Code.ForbiddenOperation, "Key to be incremented `" + key + "` does not exist in `" + this.statics().className + "`");
        // Set key to an increment value
        this[key] = specials_1.Increment.by(value);
    };
    /**
     * Set json values
     * @param classInstance
     * @param key
     * @param path
     */
    Class.prototype.json = function (key) {
        // Check if key exists
        if (!this.statics().has(key))
            throw new error_1.default(error_1.default.Code.ForbiddenOperation, "Key to be incremented `" + key + "` does not exist in `" + this.statics().className + "`");
        return {
            set: function (path, value) {
                this[key] = new specials_1.JsonAction(constants_1.SetJsonTypeName, key, path, value);
            },
            append: function (path, value) {
                this[key] = new specials_1.JsonAction(constants_1.AppendJsonTypeName, key, path, value);
            },
        };
    };
    /**
     * toSqlString
     * @description Executed every time the object is being saved to the database
     */
    Class.prototype.toSqlString = function () {
        return this.id;
    };
    /**
     * toJSON
     * @description Executed every time the object is being stringified to an object literal
     */
    Class.prototype.toJSON = function (type) {
        var e_2, _a, _b;
        // Get keys
        var _c = this, id = _c.id, createdAt = _c.createdAt, updatedAt = _c.updatedAt;
        var keys = {};
        var body = {};
        // Class definition
        var classDefinition = ClassDefinitionManager.get(this.statics());
        var iterables = classDefinition.keys.filter(function (key) { return (!classDefinition.hidden.includes(key) && !classDefinition.timestamps.includes(key)); });
        try {
            // Iterate through each key in key map
            for (var iterables_1 = __values(iterables), iterables_1_1 = iterables_1.next(); !iterables_1_1.done; iterables_1_1 = iterables_1.next()) {
                var key = iterables_1_1.value;
                // Get value
                var value = this[format_1.toCamelCase(key)];
                // Check if key is a relation and has a value
                if (typeof classDefinition.relations[key] !== 'undefined' && value instanceof Class)
                    value = value.toJSON('relation');
                // Set value
                keys[key] = value;
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (iterables_1_1 && !iterables_1_1.done && (_a = iterables_1.return)) _a.call(iterables_1);
            }
            finally { if (e_2) throw e_2.error; }
        }
        // If class is a relation, use attributes
        if (type === 'relation') {
            body = (_b = {
                    type: constants_1.RelationTypeName
                },
                _b[constants_1.InternalKeys.Relations.ClassName] = this.statics().className,
                _b[constants_1.InternalKeys.Relations.Attributes] = Object.keys(keys).length > 0 ? keys : undefined,
                _b);
        }
        else
            body = keys; // Else use the keys as-is
        // Set internal keys
        body[constants_1.InternalId] = id;
        body[constants_1.CreatedAt] = createdAt;
        body[constants_1.UpdatedAt] = updatedAt;
        // Return the object
        return body;
    };
    return Class;
}());
exports.default = Class;
//# sourceMappingURL=class.js.map