"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var error_1 = __importDefault(require("../../utils/error"));
var relation_1 = __importDefault(require("./relation"));
var constants_1 = require("../../utils/constants");
var __1 = require("../..");
/**
 * collection decorator for relations
 * @param classCaller
 * @param key
 */
exports.collection = function (classCaller, key) {
    return function (classInstance, name) {
        // Override getter and setter
        Object.defineProperty(classInstance, name, {
            set: function (value) {
                throw new error_1.default(error_1.default.Code.ForbiddenOperation, 'Cannot set the value of a `hasMany` relation');
            },
            get: function () {
                if (this.isNew)
                    throw new error_1.default(error_1.default.Code.ForbiddenOperation, 'Cannot get a `hasMany` relation for a new object');
                var relationKey = relation_1.default.formatKey(this.statics().className, constants_1.InternalKeys.Id);
                key = key || relationKey;
                return new __1.Query(classCaller()).equalTo(key, this.id);
            },
            enumerable: true,
            configurable: true,
        });
    };
};
//# sourceMappingURL=collection.js.map