import { KeyOptions } from '../../../types/key';
import Class from '../class';
/**
 * Key Manager
 * @description Handler for getters and setters
 */
export declare class KeyManager {
    private keyType;
    private keyName;
    private isNewFlag;
    setterDefinition: (value: any) => any;
    getterDefinition: (value: any) => any;
    constructor(name: string, type?: string);
    readonly type: string;
    isNew: boolean;
    readonly name: string;
    readonly setter: (value: any) => any;
    readonly getter: (value: any) => any;
}
/**
 * Key Decorator
 * @param opts
 */
export declare const keyDecorator: (opts?: KeyOptions) => <C extends Class>(classInstance: C, name: string) => any;
/**
 * Key definition
 */
declare function key<C extends Class>(): (classInstance: C, name: string) => any;
declare function key<C extends Class>(opts: KeyOptions): (classInstance: C, name: string) => any;
declare function key<C extends Class>(classInstance: C, name: string): any;
declare function key<C extends Class>(classInstance: C, name: string, descriptor: any): any;
export { key };
