"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var class_1 = require("../../class");
var format_1 = require("../../../../utils/format");
/**
 * Validates the length of a string
 * @param classInstance
 * @param name
 */
exports.enumerated = function (values) { return function (classInstance, name) {
    // Convert key name to snake case, then add to the key map
    var keyName = format_1.toSnakeCase(name);
    // Get existing descriptor
    var descriptor = Object.getOwnPropertyDescriptor(classInstance, name);
    // Get definition
    var definition = class_1.ClassDefinitionManager.get(classInstance.statics());
    if (!definition.keys.includes(keyName))
        throw new Error("Property `" + name + "` cannot be modified by `@enum()` because it is not decorated with `@key`");
    // Override getter and setter
    Object.defineProperty(classInstance, name, {
        set: function (value) {
            // Validate value
            if (values instanceof Array) {
                if (!values.includes(value))
                    throw new Error("Key `" + keyName + "` can only be set to either of the following values: " + values.join(', '));
            }
            else if (!values.has(value))
                throw new Error("Key `" + keyName + "` can only be set to either of the following values: " + __spread(values.keys()).join(', '));
            // Set value
            descriptor && descriptor.set && descriptor.set.apply(this, [value]);
        },
        get: function () {
            // Get value
            var value = descriptor && descriptor.get && descriptor.get.apply(this) || undefined;
            // Translate value
            if (values instanceof Map) {
                value = values.get(value);
            }
            // Return value
            return value;
        },
        enumerable: true,
        configurable: true,
    });
}; };
//# sourceMappingURL=enumerated.js.map