"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var class_1 = require("../../class");
var format_1 = require("../../../../utils/format");
/**
 * Adds the property to the list of guarded keys
 * @param classInstance
 * @param name
 */
exports.guarded = function (classInstance, name) {
    // Get key name
    var keyName = format_1.toSnakeCase(name);
    // Set definition
    var definition = class_1.ClassDefinitionManager.get(classInstance.statics());
    if (!definition.guarded.includes(keyName))
        definition.guarded.push(keyName);
    class_1.ClassDefinitionManager.set(classInstance.statics(), definition);
};
//# sourceMappingURL=guarded.js.map