"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var key_1 = require("../key");
var error_1 = __importDefault(require("../../../../utils/error"));
function BooleanKey(name) {
    var key = new key_1.KeyManager(name, 'boolean');
    key.setterDefinition = function (value) {
        // If null, set value to null
        if (typeof value === 'undefined' || value === null)
            return null;
        // If value is not a boolean, throw an error
        if (typeof value !== 'boolean')
            throw new error_1.default(error_1.default.Code.InvalidObjectKey, "Key `" + name + "` is not a valid date");
        return value ? 1 : 0;
    };
    key.getterDefinition = function (value) {
        // Get the date
        if (typeof value === 'undefined' || value === null)
            return value;
        else
            return value === 1 ? true : false;
    };
    return key;
}
exports.default = BooleanKey;
//# sourceMappingURL=boolean.js.map