"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var key_1 = require("../key");
var error_1 = __importDefault(require("../../../../utils/error"));
var format_1 = require("../../../../utils/format");
function DateKey(name) {
    var key = new key_1.KeyManager(name, 'date');
    key.setterDefinition = function (value) {
        // If null, set value to null
        if (typeof value === 'undefined' || value === null)
            return null;
        // If the date is not valid, throw an error
        try {
            return format_1.toDatabaseDate(value);
        }
        catch (err) {
            throw new error_1.default(error_1.default.Code.InvalidObjectKey, "Key `" + name + "` is not a valid date");
        }
    };
    key.getterDefinition = function (value) {
        // Get the date
        if (typeof value === 'undefined' || value === null)
            return value;
        else
            return format_1.toISODate(value);
    };
    return key;
}
exports.default = DateKey;
//# sourceMappingURL=date.js.map