"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var key_1 = require("../key");
var error_1 = __importDefault(require("../../../../utils/error"));
var specials_1 = require("../../specials");
function JsonKey(name) {
    var key = new key_1.KeyManager(name, 'json');
    key.setterDefinition = function (value) {
        // If null, set value to null
        if (typeof value === 'undefined' || value === null)
            return null;
        else if (typeof value === 'object') {
            if (specials_1.JsonAction.isImplementedBy(value))
                return new specials_1.JsonAction(value.type, name, value.path, value.value);
            else
                return JSON.stringify(value);
        }
        else
            throw new error_1.default(error_1.default.Code.InvalidObjectKey, "Key `" + name + "` must be a valid JSON object");
    };
    key.getterDefinition = function (value) {
        try {
            // If null, set value to null
            if (typeof value === 'undefined' || value === null)
                return value;
            else if (typeof value === 'string')
                return JSON.parse(value);
            else if (value instanceof specials_1.JsonAction)
                return null;
            else if (typeof value === 'object')
                return value;
            else
                return null;
        }
        catch (err) {
            throw new error_1.default(error_1.default.Code.InvalidObjectKey, "Key `" + name + "` could not be fetched because it is an invalid JSON object");
        }
    };
    return key;
}
exports.default = JsonKey;
//# sourceMappingURL=json.js.map