"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var key_1 = require("../key");
var error_1 = __importDefault(require("../../../../utils/error"));
function PointerKey(name, pointerDefinition) {
    var key = new key_1.KeyManager(name, 'pointer');
    key.setterDefinition = function (value) {
        // Get pointer
        var pointer = pointerDefinition.toPointer();
        // Prevent secondary pointers from being set
        if (pointer.secondary)
            throw new error_1.default(error_1.default.Code.ForbiddenOperation, "Cannot manually set secondary pointers");
        // If the value is a Class, set as-is
        if (value instanceof pointer.class)
            return value;
        else if (pointer.isImplementedBy(value))
            return new pointer.class(value.id);
        else
            throw new error_1.default(error_1.default.Code.ForbiddenOperation, "Key `" + name + "` must be a pointer to `" + pointer.class.className + "`");
    };
    key.getterDefinition = function (value) {
        // Return class value
        return value;
    };
    return key;
}
exports.default = PointerKey;
//# sourceMappingURL=pointer.js.map