"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var key_1 = require("../key");
var error_1 = __importDefault(require("../../../../utils/error"));
function RelationKey(name, relationDefinition) {
    var key = new key_1.KeyManager(name, 'relation');
    key.setterDefinition = function (value) {
        // Get relation
        var relation = relationDefinition.toRelation();
        // Prevent secondary relations from being set
        if (relation.secondary)
            throw new error_1.default(error_1.default.Code.ForbiddenOperation, "Cannot manually set secondary relations");
        // If the value is a Class, set as-is
        if (value instanceof relation.class)
            return value;
        else if (relation.isImplementedBy(value))
            return new relation.class(value.id);
        else
            throw new error_1.default(error_1.default.Code.ForbiddenOperation, "Key `" + name + "` must be a relation to `" + relation.class.className + "`");
    };
    key.getterDefinition = function (value) {
        // Return class value
        return value;
    };
    return key;
}
exports.default = RelationKey;
//# sourceMappingURL=relation.js.map