"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var constants_1 = require("../../../utils/constants");
var Increment = /** @class */ (function () {
    function Increment(key, value, min, max) {
        if (min === void 0) { min = 0; }
        this.escapeKey = function (value) { return value; };
        this.escape = function (value) { return value; };
        this.keyValue = [key, value];
        this.minimum = min;
        this.maximum = max;
    }
    Increment.isImplementedBy = function (value) {
        if (value === null)
            return false;
        if (typeof value !== 'object')
            return false;
        if (value.type !== constants_1.IncrementTypeName)
            return false;
        if (isNaN(value.value))
            return false;
        return true;
    };
    Increment.by = function (value) {
        return { type: constants_1.IncrementTypeName, value: value };
    };
    Object.defineProperty(Increment.prototype, "key", {
        get: function () {
            return this.keyValue[0];
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Increment.prototype, "value", {
        get: function () {
            return Number(this.keyValue[1]);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Increment.prototype, "min", {
        get: function () {
            return this.minimum;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Increment.prototype, "max", {
        get: function () {
            return this.maximum;
        },
        enumerable: true,
        configurable: true
    });
    Increment.prototype.toSqlString = function () {
        var escaped = "GREATEST(IFNULL(" + this.escapeKey(this.key) + ", 0) + (" + this.escape(this.value) + "), " + this.min + ")";
        if (typeof this.max !== 'undefined')
            escaped = "LEAST(" + escaped + ", " + this.max + ")";
        return escaped;
    };
    return Increment;
}());
exports.default = Increment;
//# sourceMappingURL=increment.js.map