"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var constants_1 = require("../../../utils/constants");
var JsonAction = /** @class */ (function () {
    function JsonAction(type, key, path, value) {
        this.escapeKey = function (value) { return value; };
        this.escape = function (value) { return value; };
        this.type = type;
        this.keyValue = [key, value];
        this.pathName = path;
    }
    JsonAction.isImplementedBy = function (value) {
        if (value === null)
            return false;
        if (![constants_1.SetJsonTypeName, constants_1.AppendJsonTypeName].includes(value.type))
            return false;
        return true;
    };
    Object.defineProperty(JsonAction.prototype, "key", {
        get: function () {
            return this.keyValue[0];
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(JsonAction.prototype, "value", {
        get: function () {
            return this.keyValue[1];
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(JsonAction.prototype, "path", {
        get: function () {
            return this.pathName;
        },
        enumerable: true,
        configurable: true
    });
    JsonAction.prototype.toSqlString = function () {
        if (this.type === constants_1.SetJsonTypeName) {
            var key = "IFNULL(" + this.escapeKey(this.key) + ", JSON_OBJECT())";
            var path = this.escape(this.path);
            var value = typeof this.value === 'object' ? "CAST(" + this.escape(JSON.stringify(this.value)) + " AS JSON)" : this.escape(this.value);
            return "JSON_SET(" + key + ", " + path + ", " + value + ")";
        }
        else if (this.type === constants_1.AppendJsonTypeName) {
            var key = "IFNULL(" + this.escapeKey(this.key) + ", JSON_ARRAY())";
            var path = this.escape(this.path);
            var val = typeof this.value === 'object' ? "CAST(" + this.escape(JSON.stringify(this.value)) + " AS JSON)" : this.escape(this.value);
            return "JSON_ARRAY_APPEND(" + key + ", " + path + ", " + val + ")";
        }
    };
    return JsonAction;
}());
exports.JsonAction = JsonAction;
//# sourceMappingURL=json.js.map