"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
require("reflect-metadata");
var express_1 = require("express");
var enforce_js_1 = __importDefault(require("enforce-js"));
var chalk_1 = __importDefault(require("chalk"));
var class_1 = __importDefault(require("./features/orm/class"));
exports.Class = class_1.default;
var query_1 = __importDefault(require("./features/orm/query"));
exports.Query = query_1.default;
var user_1 = __importDefault(require("./features/auth/user"));
exports.User = user_1.default;
var function_1 = __importDefault(require("./features/functions/function"));
exports.Function = function_1.default;
var class_manager_1 = __importDefault(require("./features/orm/class-manager"));
exports.ClassManager = class_manager_1.default;
var function_manager_1 = __importDefault(require("./features/functions/function-manager"));
var database_1 = __importDefault(require("./adapters/database"));
var logger_1 = __importDefault(require("./adapters/logger"));
var middleware_1 = __importDefault(require("./routes/middleware"));
var classes_1 = __importDefault(require("./routes/classes"));
var functions_1 = __importDefault(require("./routes/functions"));
var class_2 = __importDefault(require("./controllers/class"));
var function_2 = __importDefault(require("./controllers/function"));
var collection_1 = __importDefault(require("./utils/collection"));
exports.Collection = collection_1.default;
var response_1 = __importDefault(require("./utils/response"));
var validation_1 = __importDefault(require("./utils/validation"));
var version = require('./package.json').version;
/**
 * Initialize validation
 */
validation_1.default.initialize();
/**
 * @class Warp
 * @description Warp definition
 */
var Warp = /** @class */ (function () {
    /**
     * Constructor
     * @param {Object} config
     */
    function Warp(_a) {
        var databaseURI = _a.databaseURI, _b = _a.apiKey, apiKey = _b === void 0 ? '' : _b, _c = _a.masterKey, masterKey = _c === void 0 ? '' : _c, _d = _a.persistent, persistent = _d === void 0 ? false : _d, customResponse = _a.customResponse, restful = _a.restful;
        this.classController = new class_2.default(this);
        this.functionController = new function_2.default(this);
        // Set logger
        this.setLogger('console');
        // Set security
        this.setSecurity({ apiKey: apiKey, masterKey: masterKey });
        // Set class manager
        this.setClassManager(databaseURI, persistent);
        // Set action mapper
        this.setFunctionManager();
        // Set response format
        this.setResponse(customResponse);
        // Set router
        this.setRouter(restful);
    }
    Object.defineProperty(Warp, "Class", {
        get: function () {
            return class_1.default;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Warp, "User", {
        get: function () {
            return user_1.default;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Warp, "Query", {
        get: function () {
            return query_1.default;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Warp.prototype, "apiKey", {
        /**
         * API Key
         */
        get: function () {
            return this.security.apiKey;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Warp.prototype, "masterKey", {
        /**
         * Master Key
         */
        get: function () {
            return this.security.masterKey;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Warp.prototype, "classes", {
        /**
         * Class operations
         */
        get: function () {
            return this.classManager;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Warp.prototype, "functions", {
        /**
         * Function operations
         */
        get: function () {
            return this.functionManager;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Warp.prototype, "logger", {
        /**
         * Logger
         */
        get: function () {
            return this.loggerInstance;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Warp.prototype, "response", {
        /**
         * Response format
         */
        get: function () {
            return this.responseInstance;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Warp.prototype, "controllers", {
        /**
         * Get controllers
         */
        get: function () {
            return Object.freeze({
                class: this.classController,
                function: this.functionController,
            });
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Warp.prototype, "_classController", {
        // @deprecated - backwards compatibility
        get: function () {
            return this.classController;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Warp.prototype, "_functionController", {
        // @deprecated - backwards compatibility
        get: function () {
            return this.functionController;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Warp.prototype, "router", {
        /**
         * Get express router
         */
        get: function () {
            // Return the router
            return this.routerInstance;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Set logger
     * @param customResponse
     */
    Warp.prototype.setLogger = function (channel) {
        this.loggerInstance = logger_1.default.use(channel, 'Warp Server', process.env.WARP_LOG_LEVEL || 'error');
    };
    /**
     * Set security configuration
     * @param {Object} config
     */
    Warp.prototype.setSecurity = function (_a) {
        var apiKey = _a.apiKey, masterKey = _a.masterKey;
        // Enforce
        enforce_js_1.default(templateObject_1 || (templateObject_1 = __makeTemplateObject(["", " as a string"], ["", " as a string"])), { apiKey: apiKey });
        enforce_js_1.default(templateObject_2 || (templateObject_2 = __makeTemplateObject(["", " as a string"], ["", " as a string"])), { masterKey: masterKey });
        // Set keys
        this.security = {
            apiKey: apiKey,
            masterKey: masterKey,
        };
    };
    /**
     * Set data mapper configuration
     * @param {Object} config
     */
    Warp.prototype.setClassManager = function (databaseURI, persistent) {
        // Get uris
        var uris = [];
        // Check if uri is a string
        if (typeof databaseURI === 'string') {
            uris = [
                { uri: databaseURI, action: 'read' },
                { uri: databaseURI, action: 'write' },
            ];
        }
        else if (databaseURI instanceof Array) {
            uris = __spread(databaseURI);
        }
        else {
            throw new Error("'databaseURI' must be a string or an array of configs");
        }
        // Get database protocol
        var protocol = uris[0].uri.split(':')[0];
        // Prepare database
        var database = database_1.default.use(protocol, { uris: uris, persistent: persistent, logger: this.logger });
        // Set data mapper
        this.classManager = new class_manager_1.default(database);
    };
    /**
     * Set action mapper configuration
     */
    Warp.prototype.setFunctionManager = function () {
        // Set action mapper
        this.functionManager = new function_manager_1.default();
    };
    /**
     * Set response format
     * @param customResponse
     */
    Warp.prototype.setResponse = function (customize) {
        this.responseInstance = new response_1.default(customize);
    };
    /**
     * Set router
     * @param restful
     */
    Warp.prototype.setRouter = function (restful) {
        if (restful === void 0) { restful = false; }
        // Prepare routers
        var router = express_1.Router();
        router.use(middleware_1.default(this));
        router.use(functions_1.default(this));
        // Only use class routers when restful
        if (restful)
            router.use(classes_1.default(this));
        // Set the router instance
        this.routerInstance = router;
    };
    /**
     * Initialize the server and connect to the database
     */
    Warp.prototype.initialize = function () {
        return __awaiter(this, void 0, void 0, function () {
            var err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        this.loggerInstance.info('Starting Warp Server...');
                        // Attempt to connect to the database
                        return [4 /*yield*/, this.classManager.initialize()];
                    case 1:
                        // Attempt to connect to the database
                        _a.sent();
                        // Display startup screen
                        this.loggerInstance.bare(chalk_1.default.hex('#E8822F')("\n                MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM\n                MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM\n                MMMMMMMNmMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM\n                MMMMMMMMhhmMMMMMMMMMMMMMMMMMMMMMMMNNMMMMMMM\n                MMMMMMMMNyshNMMMMMMMMMMMMMMMMMMMMNhMMMMMMMM\n                MMMMMMMMMmssshNMMMMMMMMMMMMMMMMMMymMMMMMMMM\n                MMMMMMMMMMhsssshNMMMMMMmhNMMMMMMhhMMMMMMMMM\n                MMMMMMMMMMMyssssshNMMMMysshNMMMhsmMMMMMMMMM\n                MMMMMMMMMMMmssssssshNMdssssshmhshMMMMMMMMMM\n                MMMMMMMMMMMMdsssssssNNysssssssssNMMMMMMMMMM\n                MMMMMMMMMMMMMyssssshMyssssssssshMMMMMMMMMMM\n                MMMMMMMMMMMMMNyssssmdssshNmhsssNMMMMMMMMMMM\n                MMMMMMMMMMMMMMdsssyNysymMMMMNddMMMMMMMMMMMM\n                MMMMMMMMMMMMMMMhssmhshMMMMMMMMMMMMMMMMMMMMM\n                MMMMMMMMMMMMMMMNyymymMMMMMMMMMMMMMMMMMMMMMM\n                MMMMMMMMMMMMMMMMmddMMMMMMMMMMMMMMMMMMMMMMMM\n                MMMMMMMMMMMMMMMMMNMMMMMMMMMMMMMMMMMMMMMMMMM\n                MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM\n\n                           Warp Server " + version + "\n\n                +-----------------------------------------+\n                |     The server has been initialized     |\n                +-----------------------------------------+\n            "));
                        this.loggerInstance.info('Service started');
                        return [3 /*break*/, 3];
                    case 2:
                        err_1 = _a.sent();
                        this.loggerInstance.error(err_1, err_1.message);
                        return [3 /*break*/, 3];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    return Warp;
}());
exports.Warp = Warp;
exports.default = Warp;
/**
 * Export features
 */
var class_3 = require("./features/orm/class");
exports.define = class_3.define;
var key_1 = require("./features/orm/keys/key");
exports.key = key_1.key;
var hidden_1 = require("./features/orm/keys/modifiers/hidden");
exports.hidden = hidden_1.hidden;
var guarded_1 = require("./features/orm/keys/modifiers/guarded");
exports.guarded = guarded_1.guarded;
var length_1 = require("./features/orm/keys/modifiers/length");
exports.length = length_1.length;
var min_1 = require("./features/orm/keys/modifiers/min");
exports.min = min_1.min;
var max_1 = require("./features/orm/keys/modifiers/max");
exports.max = max_1.max;
var between_1 = require("./features/orm/keys/modifiers/between");
exports.between = between_1.between;
var rounded_1 = require("./features/orm/keys/modifiers/rounded");
exports.rounded = rounded_1.rounded;
var enumerated_1 = require("./features/orm/keys/modifiers/enumerated");
exports.enumerated = enumerated_1.enumerated;
var triggers_1 = require("./features/orm/keys/modifiers/triggers");
exports.beforeFind = triggers_1.beforeFind;
exports.beforeFirst = triggers_1.beforeFirst;
exports.beforeGet = triggers_1.beforeGet;
exports.beforeSave = triggers_1.beforeSave;
exports.afterSave = triggers_1.afterSave;
exports.beforeDestroy = triggers_1.beforeDestroy;
exports.afterDestroy = triggers_1.afterDestroy;
var templateObject_1, templateObject_2;
//# sourceMappingURL=index.js.map