"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var express_1 = __importDefault(require("express"));
var enforce_js_1 = __importDefault(require("enforce-js"));
var class_1 = __importDefault(require("../controllers/class"));
var constants_1 = require("../utils/constants");
var error_1 = __importDefault(require("../utils/error"));
/**
 * Define router
 */
var classes = function (api) {
    /**
     * Define controller
     */
    var controller = new class_1.default(api);
    /**
     * Define router
     */
    var router = express_1.default.Router();
    /**
     * Finding objects
     */
    router.get('/classes/:className', function (req, res, next) { return __awaiter(_this, void 0, void 0, function () {
        var className, _a, select, include, where, sort, skip, limit, user, params, classCollection, err_1;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    className = req.params.className;
                    _a = req.query, select = _a.select, include = _a.include, where = _a.where, sort = _a.sort, skip = _a.skip, limit = _a.limit;
                    user = req[constants_1.InternalKeys.Middleware.User];
                    _b.label = 1;
                case 1:
                    _b.trys.push([1, 3, , 4]);
                    // Enforce
                    enforce_js_1.default(templateObject_1 || (templateObject_1 = __makeTemplateObject(["", " as an optional string, equivalent to an array"], ["", " as an optional string, equivalent to an array"])), { select: select });
                    enforce_js_1.default(templateObject_2 || (templateObject_2 = __makeTemplateObject(["", " as an optional string, equivalent to an array"], ["", " as an optional string, equivalent to an array"])), { include: include });
                    enforce_js_1.default(templateObject_3 || (templateObject_3 = __makeTemplateObject(["", " as an optional string, equivalent to an object"], ["", " as an optional string, equivalent to an object"])), { where: where });
                    enforce_js_1.default(templateObject_4 || (templateObject_4 = __makeTemplateObject(["", " as an optional string, equivalent to an array"], ["", " as an optional string, equivalent to an array"])), { sort: sort });
                    enforce_js_1.default(templateObject_5 || (templateObject_5 = __makeTemplateObject(["", " as an optional number"], ["", " as an optional number"])), { skip: skip });
                    enforce_js_1.default(templateObject_6 || (templateObject_6 = __makeTemplateObject(["", " as an optional number"], ["", " as an optional number"])), { limit: limit });
                    params = {
                        className: className,
                        select: typeof select !== 'undefined' ? JSON.parse(select) : undefined,
                        include: typeof include !== 'undefined' ? JSON.parse(include) : undefined,
                        where: typeof where !== 'undefined' ? JSON.parse(where) : undefined,
                        sort: typeof sort !== 'undefined' ? JSON.parse(sort) : undefined,
                        skip: skip,
                        limit: limit,
                        user: user,
                    };
                    return [4 /*yield*/, controller.find(params)];
                case 2:
                    classCollection = _b.sent();
                    // Return response
                    req[constants_1.InternalKeys.Middleware.Result] = classCollection;
                    api.response.success(req, res, next);
                    return [3 /*break*/, 4];
                case 3:
                    err_1 = _b.sent();
                    // Check if class was not found
                    if (err_1.code === error_1.default.Code.ClassNotFound) {
                        api.logger.warn(err_1, "Could not find the objects for `" + className + "`: " + err_1.message);
                        next();
                    }
                    else {
                        api.logger.error(err_1, "Could not find the objects for `" + className + "`: " + err_1.message);
                        api.response.error(err_1, req, res, next);
                    }
                    return [3 /*break*/, 4];
                case 4: return [2 /*return*/];
            }
        });
    }); });
    /**
     * Finding a single object
     */
    router.get('/classes/:className/:id', function (req, res, next) { return __awaiter(_this, void 0, void 0, function () {
        var _a, className, id, _b, include, select, user, params, classInstance, err_2;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    _a = req.params, className = _a.className, id = _a.id;
                    _b = req.query, include = _b.include, select = _b.select;
                    user = req[constants_1.InternalKeys.Middleware.User];
                    _c.label = 1;
                case 1:
                    _c.trys.push([1, 3, , 4]);
                    // Enforce
                    enforce_js_1.default(templateObject_7 || (templateObject_7 = __makeTemplateObject(["", " as an optional string, equivalent to an array"], ["", " as an optional string, equivalent to an array"])), { include: include });
                    enforce_js_1.default(templateObject_8 || (templateObject_8 = __makeTemplateObject(["", " as an optional string, equivalent to an array"], ["", " as an optional string, equivalent to an array"])), { select: select });
                    params = {
                        className: className,
                        id: id,
                        include: typeof include !== 'undefined' ? JSON.parse(include) : undefined,
                        select: typeof select !== 'undefined' ? JSON.parse(select) : undefined,
                        user: user,
                    };
                    return [4 /*yield*/, controller.get(params)];
                case 2:
                    classInstance = _c.sent();
                    // Return response
                    req[constants_1.InternalKeys.Middleware.Result] = classInstance;
                    api.response.success(req, res, next);
                    return [3 /*break*/, 4];
                case 3:
                    err_2 = _c.sent();
                    // Check if class was not found
                    if (err_2.code === error_1.default.Code.ClassNotFound) {
                        api.logger.warn(err_2, "Could not find the object for `" + className + "`: " + err_2.message);
                        next();
                    }
                    else {
                        api.logger.error(err_2, "Could not find the object for `" + className + "`: " + err_2.message);
                        api.response.error(err_2, req, res, next);
                    }
                    return [3 /*break*/, 4];
                case 4: return [2 /*return*/];
            }
        });
    }); });
    /**
     * Creating objects
     */
    router.post('/classes/:className', function (req, res, next) { return __awaiter(_this, void 0, void 0, function () {
        var className, keys, user, classInstance, err_3;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    className = req.params.className;
                    keys = req.body;
                    user = req[constants_1.InternalKeys.Middleware.User];
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, controller.create({ className: className, keys: keys, user: user })];
                case 2:
                    classInstance = _a.sent();
                    // Return response
                    req[constants_1.InternalKeys.Middleware.Result] = classInstance;
                    api.response.success(req, res, next);
                    return [3 /*break*/, 4];
                case 3:
                    err_3 = _a.sent();
                    // Check if class was not found
                    if (err_3.code === error_1.default.Code.ClassNotFound) {
                        api.logger.warn(err_3, "Could not create the object for `" + className + "`: " + err_3.message);
                        next();
                    }
                    else {
                        api.logger.error(err_3, "Could not create the object for `" + className + "`: " + err_3.message);
                        api.response.error(err_3, req, res, next);
                    }
                    return [3 /*break*/, 4];
                case 4: return [2 /*return*/];
            }
        });
    }); });
    /**
     * Updating objects
     */
    router.put('/classes/:className/:id', function (req, res, next) { return __awaiter(_this, void 0, void 0, function () {
        var _a, className, id, keys, user, classInstance, err_4;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _a = req.params, className = _a.className, id = _a.id;
                    keys = req.body;
                    user = req[constants_1.InternalKeys.Middleware.User];
                    _b.label = 1;
                case 1:
                    _b.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, controller.update({ className: className, keys: keys, id: id, user: user })];
                case 2:
                    classInstance = _b.sent();
                    // Return response
                    req[constants_1.InternalKeys.Middleware.Result] = classInstance;
                    api.response.success(req, res, next);
                    return [3 /*break*/, 4];
                case 3:
                    err_4 = _b.sent();
                    // Check if class was not found
                    if (err_4.code === error_1.default.Code.ClassNotFound) {
                        api.logger.warn(err_4, "Could not update the object for `" + className + "`: " + err_4.message);
                        next();
                    }
                    else {
                        api.logger.error(err_4, "Could not update the object for `" + className + "`: " + err_4.message);
                        api.response.error(err_4, req, res, next);
                    }
                    return [3 /*break*/, 4];
                case 4: return [2 /*return*/];
            }
        });
    }); });
    /**
     * Destroying objects
     */
    router.delete('/classes/:className/:id', function (req, res, next) { return __awaiter(_this, void 0, void 0, function () {
        var _a, className, id, user, classInstance, err_5;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _a = req.params, className = _a.className, id = _a.id;
                    user = req[constants_1.InternalKeys.Middleware.User];
                    _b.label = 1;
                case 1:
                    _b.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, controller.destroy({ className: className, id: id, user: user })];
                case 2:
                    classInstance = _b.sent();
                    // Return response
                    req[constants_1.InternalKeys.Middleware.Result] = classInstance;
                    api.response.success(req, res, next);
                    return [3 /*break*/, 4];
                case 3:
                    err_5 = _b.sent();
                    // Check if class was not found
                    if (err_5.code === error_1.default.Code.ClassNotFound) {
                        api.logger.warn(err_5, "Could not destroy the object for `" + className + "`: " + err_5.message);
                        next();
                    }
                    else {
                        api.logger.error(err_5, "Could not destroy the object for `" + className + "`: " + err_5.message);
                        api.response.error(err_5, req, res, next);
                    }
                    return [3 /*break*/, 4];
                case 4: return [2 /*return*/];
            }
        });
    }); });
    return router;
};
exports.default = classes;
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5, templateObject_6, templateObject_7, templateObject_8;
//# sourceMappingURL=classes.js.map