import { TriggerBeforeFind, TriggerBeforeFirst, TriggerBeforeGet, TriggerBeforeSave, TriggerAfterSave, TriggerBeforeDestroy, TriggerAfterDestroy } from '../utils/constants';
import Query from '../features/orm/query';
import Class from '../features/orm/class';
import User from '../features/auth/user';
import { ClassManager, ClassOptions } from '..';
export declare type TriggerType = typeof TriggerBeforeFind | typeof TriggerBeforeFirst | typeof TriggerBeforeGet | typeof TriggerBeforeSave | typeof TriggerAfterSave | typeof TriggerBeforeDestroy | typeof TriggerAfterDestroy;
export declare type TriggerQueryAction = <C extends typeof Class, U extends User>(query: Query<C>, opts: ClassOptions<U>) => any;
export declare type TriggerMutationAction = <U extends User>(classes: ClassManager, opts: ClassOptions<U>) => any;
export declare type TriggerAction = TriggerQueryAction | TriggerMutationAction;
export declare type TriggersList = Array<{
    type: TriggerType;
    action: TriggerAction;
}>;
