"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
Object.defineProperty(exports, "__esModule", { value: true });
var format_1 = require("./format");
var constants_1 = require("./constants");
var Collection = /** @class */ (function () {
    function Collection(collection) {
        this.collection = collection;
    }
    Object.defineProperty(Collection.prototype, "length", {
        get: function () {
            return this.collection.length;
        },
        enumerable: true,
        configurable: true
    });
    Collection.prototype.count = function () {
        return this.length;
    };
    /**
     * Get the first item from the collection
     */
    Collection.prototype.first = function () {
        return this.collection.length > 0 ? this.collection[0] : null;
    };
    /**
     * Get the last Object from the collection
     */
    Collection.prototype.last = function () {
        return this.collection.length > 0 ? this.collection[this.collection.length - 1] : null;
    };
    /**
     * Return Objects that pass a given evaluator
     * @param {Function} evaluator
     */
    Collection.prototype.where = function (evaluator) {
        var e_1, _a;
        var objects = __spread(this.collection);
        var map = [];
        try {
            for (var objects_1 = __values(objects), objects_1_1 = objects_1.next(); !objects_1_1.done; objects_1_1 = objects_1.next()) {
                var object = objects_1_1.value;
                if (evaluator(object)) {
                    map.push(object);
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (objects_1_1 && !objects_1_1.done && (_a = objects_1.return)) _a.call(objects_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        var constructor = this.constructor;
        return new constructor(map);
    };
    /**
     * Map Objects into an array using an iterator
     * @param {Function} iterator
     */
    Collection.prototype.map = function (iterator) {
        var e_2, _a;
        var objects = __spread(this.collection);
        var map = [];
        try {
            for (var objects_2 = __values(objects), objects_2_1 = objects_2.next(); !objects_2_1.done; objects_2_1 = objects_2.next()) {
                var object = objects_2_1.value;
                map.push(iterator(object));
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (objects_2_1 && !objects_2_1.done && (_a = objects_2.return)) _a.call(objects_2);
            }
            finally { if (e_2) throw e_2.error; }
        }
        return map;
    };
    /**
     * Iterate through each item
     * @param {Function} iterator
     */
    Collection.prototype.forEach = function (iterator) {
        var e_3, _a;
        var objects = __spread(this.collection);
        try {
            for (var objects_3 = __values(objects), objects_3_1 = objects_3.next(); !objects_3_1.done; objects_3_1 = objects_3.next()) {
                var object = objects_3_1.value;
                iterator(object);
            }
        }
        catch (e_3_1) { e_3 = { error: e_3_1 }; }
        finally {
            try {
                if (objects_3_1 && !objects_3_1.done && (_a = objects_3.return)) _a.call(objects_3);
            }
            finally { if (e_3) throw e_3.error; }
        }
    };
    /**
     * Alias of toArray()
     */
    Collection.prototype.toList = function () {
        return this.toArray();
    };
    /**
     * Convert the collection into an array
     */
    Collection.prototype.toArray = function () {
        return this.collection.map(function (object) { return object; });
    };
    /**
     * Convert the collection into a Map, based on the given iterator
     * @param iterator
     */
    Collection.prototype.toMap = function (iterator) {
        if (iterator === void 0) { iterator = constants_1.InternalId; }
        // Get key
        var getKey = typeof iterator === 'function' ? iterator : function (object) { return object[format_1.toCamelCase(iterator)]; };
        // Return a map
        var entries = this.collection.map(function (object) { return [getKey(object), object]; });
        return new Map(entries);
    };
    /**
     * Convert the collection into an object literal
     */
    Collection.prototype.toJSON = function () {
        return this.collection.map(function (object) { return object.toJSON(); });
    };
    /**
     * Run a promise iterator over every Object, in series
     * @param {Function} iterator
     */
    Collection.prototype.each = function (iterator) {
        return __awaiter(this, void 0, void 0, function () {
            var e_4, _a, objects, objects_4, objects_4_1, object, e_4_1;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        objects = __spread(this.collection);
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 6, 7, 8]);
                        objects_4 = __values(objects), objects_4_1 = objects_4.next();
                        _b.label = 2;
                    case 2:
                        if (!!objects_4_1.done) return [3 /*break*/, 5];
                        object = objects_4_1.value;
                        return [4 /*yield*/, iterator(object)];
                    case 3:
                        _b.sent();
                        _b.label = 4;
                    case 4:
                        objects_4_1 = objects_4.next();
                        return [3 /*break*/, 2];
                    case 5: return [3 /*break*/, 8];
                    case 6:
                        e_4_1 = _b.sent();
                        e_4 = { error: e_4_1 };
                        return [3 /*break*/, 8];
                    case 7:
                        try {
                            if (objects_4_1 && !objects_4_1.done && (_a = objects_4.return)) _a.call(objects_4);
                        }
                        finally { if (e_4) throw e_4.error; }
                        return [7 /*endfinally*/];
                    case 8: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Run a promise iterator over every Object, in parallel
     */
    Collection.prototype.all = function (iterator) {
        return __awaiter(this, void 0, void 0, function () {
            var iterators;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        iterators = this.map(function (object) { return iterator(object); });
                        return [4 /*yield*/, Promise.all(iterators)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Collection.prototype[Symbol.iterator] = function () {
        var _this = this;
        // Set index to 0
        var index = 0;
        return {
            next: function () {
                // Return iterator result
                return { value: _this.collection[index++], done: index >= _this.collection.length };
            },
        };
    };
    return Collection;
}());
exports.default = Collection;
//# sourceMappingURL=collection.js.map