"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.InternalId = 'id';
exports.CreatedAt = 'created_at';
exports.UpdatedAt = 'updated_at';
exports.DeletedAt = 'deleted_at';
exports.InternalTimestamps = Object.freeze({ CreatedAt: exports.CreatedAt, UpdatedAt: exports.UpdatedAt, DeletedAt: exports.DeletedAt });
exports.TriggerBeforeFind = 'before-find';
exports.TriggerBeforeFirst = 'before-first';
exports.TriggerBeforeGet = 'before-get';
exports.TriggerBeforeSave = 'before-save';
exports.TriggerAfterSave = 'after-save';
exports.TriggerBeforeDestroy = 'before-destroy';
exports.TriggerAfterDestroy = 'after-destroy';
exports.SortSymbol = '-';
exports.SortAscending = 'ascending';
exports.SortDescending = 'descending';
exports.RelationDelimiter = '.';
exports.RelationTypeName = 'Relation';
exports.CompoundDelimiter = '|';
exports.IncrementTypeName = 'Increment';
exports.SetJsonTypeName = 'SetJson';
exports.AppendJsonTypeName = 'AppendJson';
exports.InternalKeys = Object.freeze({
    Middleware: Object.freeze({
        ApiKey: 'X-Warp-API-Key',
        MasterKey: 'X-Warp-Master-Key',
        User: 'user',
        Result: 'result',
        ClassManager: 'classes',
    }),
    Relations: Object.freeze({
        Type: 'type',
        ClassName: 'class_name',
        Attributes: 'attributes',
    }),
    Auth: Object.freeze({
        User: 'user',
        Username: 'username',
        Email: 'email',
        Password: 'password',
    }),
});
exports.DatabaseWrite = 'write';
exports.DatabaseRead = 'read';
exports.Defaults = Object.freeze({
    Query: Object.freeze({
        Sort: [exports.InternalId],
        Skip: 0,
        Limit: 100,
    }),
});
exports.AccessFind = 'find';
exports.AccessGet = 'get';
exports.AccessCreate = 'create';
exports.AccessUpdate = 'update';
exports.AccessDestroy = 'destroy';
exports.AccessRun = 'run';
//# sourceMappingURL=constants.js.map