export interface ConstraintObject {
    key: string;
    constraint: string;
    value: any;
}
export declare class KeyConstraints {
    /**
     * Private properties
     */
    private keyName;
    private map;
    /**
     * Constructor
     * @param {String} key
     * @param {Object} list
     * @param {String} key
     */
    constructor(key: string, map: {
        [constraint: string]: any;
    });
    readonly key: string;
    readonly constraints: ConstraintObject[];
    set(constraint: string, value: any): void;
    changeKey(newKey: string): void;
    toJSON(): object;
}
export declare const Subqueries: Readonly<{
    FoundIn: string;
    FoundInEither: string;
    FoundInAll: string;
    NotFoundIn: string;
    NotFoundInEither: string;
    NotFoundInAll: string;
}>;
export declare const Constraints: Readonly<{
    FoundIn: string;
    FoundInEither: string;
    FoundInAll: string;
    NotFoundIn: string;
    NotFoundInEither: string;
    NotFoundInAll: string;
    EqualTo: string;
    NotEqualTo: string;
    GreaterThan: string;
    GreaterThanOrEqualTo: string;
    LessThan: string;
    LessThanOrEqualTo: string;
    Exists: string;
    ContainedIn: string;
    NotContainedIn: string;
    ContainedInOrDoesNotExist: string;
    StartsWith: string;
    EndsWith: string;
    Contains: string;
    ContainsEither: string;
    ContainsAll: string;
}>;
export default class ConstraintMap {
    /**
     * Private properties
     */
    private map;
    /**
     * Constructor
     * @param {Object} keyValuePairs
     */
    constructor(constraints?: {
        [key: string]: {
            [key: string]: any;
        };
    });
    readonly keys: string[];
    set(key: string, constraint: string, value: any): void;
    changeKey(key: string, newKey: string): void;
    get(key: string): KeyConstraints;
    toArray(): KeyConstraints[];
    toJSON(): {};
}
