"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var WarpError = /** @class */ (function (_super) {
    __extends(WarpError, _super);
    function WarpError(code, message) {
        var _this = _super.call(this, message) || this;
        /**
         * Public properties
         */
        _this.name = 'Warp Server Error';
        _this.code = code;
        return _this;
    }
    Object.defineProperty(WarpError, "Code", {
        get: function () {
            return Object.freeze({
                MissingConfiguration: 300,
                InternalServerError: 100,
                QueryError: 101,
                InvalidCredentials: 102,
                InvalidSessionToken: 103,
                InvalidObjectKey: 104,
                InvalidRelation: 105,
                ForbiddenOperation: 106,
                UsernameTaken: 107,
                EmailTaken: 108,
                InvalidAPIKey: 109,
                ClassNotFound: 110,
                FunctionNotFound: 111,
                RequestTimeout: 112,
                FunctionError: 113,
                TooManyRequests: 114,
                DatabaseError: 115,
            });
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(WarpError, "Status", {
        get: function () {
            return Object.freeze({
                ServerError: 400,
                Unauthorized: 401,
                Forbidden: 403,
                NotFound: 404,
                RequestTimeout: 408,
                TooManyRequests: 429,
            });
        },
        enumerable: true,
        configurable: true
    });
    WarpError.prototype.statics = function () {
        return this.constructor;
    };
    Object.defineProperty(WarpError.prototype, "status", {
        get: function () {
            if (this.code === this.statics().Code.InvalidCredentials
                || this.code === this.statics().Code.InvalidSessionToken
                || this.code === this.statics().Code.UsernameTaken
                || this.code === this.statics().Code.EmailTaken) {
                return this.statics().Status.Unauthorized;
            }
            else if (this.code === this.statics().Code.ForbiddenOperation) {
                return this.statics().Status.Forbidden;
            }
            else if (this.code === this.statics().Code.ClassNotFound
                || this.code === this.statics().Code.FunctionNotFound) {
                return this.statics().Status.NotFound;
            }
            else if (this.code === this.statics().Code.RequestTimeout) {
                return this.statics().Status.RequestTimeout;
            }
            else if (this.code === this.statics().Code.TooManyRequests) {
                return this.statics().Status.TooManyRequests;
            }
            else {
                return this.statics().Status.ServerError;
            }
        },
        enumerable: true,
        configurable: true
    });
    return WarpError;
}(Error));
exports.default = WarpError;
//# sourceMappingURL=error.js.map