"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.toCamelCase = function (value) {
    return value.replace(/_\w/g, function (word) { return word[1].toUpperCase(); });
};
exports.toPascalCase = function (value) {
    value = exports.toCamelCase(value);
    value = value[0].toUpperCase() + value.slice(1);
    return value;
};
exports.toSnakeCase = function (value) {
    return value.replace(/\.?([A-Z]+)/g, function (word) { return '_' + word.toLowerCase(); }).replace(/^_/, '');
};
exports.toDatabaseDate = function (value) {
    return (new Date(value)).toISOString().slice(0, 19).replace('T', ' ');
};
exports.toISODate = function (value) {
    return (new Date(value + '+00:00')).toISOString();
};
exports.addToDate = function (value, span) {
    var _a = __read(span.split(' '), 2), duration = _a[0], unit = _a[1];
    var date = new Date(value);
    var result = new Date(date);
    var unitMap = {
        minute: function () { return result.setMinutes(result.getMinutes() + parseFloat(duration)); },
        minutes: function () { return result.setMinutes(result.getMinutes() + parseFloat(duration)); },
        hour: function () { return result.setHours(result.getHours() + parseFloat(duration)); },
        hours: function () { return result.setHours(result.getHours() + parseFloat(duration)); },
        day: function () { return result.setDate(result.getDate() + parseFloat(duration)); },
        days: function () { return result.setDate(result.getDate() + parseFloat(duration)); },
        month: function () { return result.setMonth(result.getMonth() + parseFloat(duration)); },
        months: function () { return result.setMonth(result.getMonth() + parseFloat(duration)); },
        year: function () { return result.setFullYear(result.getFullYear() + parseFloat(duration)); },
        years: function () { return result.setFullYear(result.getFullYear() + parseFloat(duration)); },
    };
    unitMap[unit]();
    return result;
};
exports.toDateTime = function (value) {
    if (!value)
        return new Date();
    else
        return new Date(value);
};
//# sourceMappingURL=format.js.map