"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var error_1 = __importDefault(require("./error"));
var constants_1 = require("./constants");
var Response = /** @class */ (function () {
    function Response(customize) {
        if (customize === void 0) { customize = false; }
        this.customResponse = false;
        this.customResponse = customize;
    }
    Response.prototype.success = function (req, res, next) {
        // Check if response success exists
        if (this.customResponse)
            next();
        else {
            // Set result
            var result = req[constants_1.InternalKeys.Middleware.Result];
            // Set status and response
            res.status(200);
            res.json({ result: result });
        }
    };
    Response.prototype.error = function (err, req, res, next) {
        // Check if response error exists
        if (this.customResponse)
            next(err);
        else {
            // Set code and message
            var status = err.status;
            var code = err.code;
            var message = err.message;
            // Check error code
            if (typeof err.code === 'undefined') {
                code = 400;
            }
            else if (err.code === error_1.default.Code.DatabaseError) {
                message = 'Invalid query request';
            }
            // Set status
            res.status(status || 400);
            res.json({ code: code, message: message });
        }
    };
    return Response;
}());
exports.default = Response;
//# sourceMappingURL=response.js.map