"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var enforce_js_1 = __importDefault(require("enforce-js"));
var Validation = /** @class */ (function () {
    function Validation() {
    }
    Validation.initialize = function () {
        enforce_js_1.default.extend(/^equivalent to an array$/i, function (val) {
            try {
                var parsedValue = JSON.parse(val);
                if (parsedValue instanceof Array)
                    return true;
                else
                    return false;
            }
            catch (err) {
                return false;
            }
        });
        enforce_js_1.default.extend(/^equivalent to an object$/i, function (val) {
            try {
                var parsedValue = JSON.parse(val);
                if (typeof parsedValue === 'object')
                    return true;
                else
                    return false;
            }
            catch (err) {
                return false;
            }
        });
        enforce_js_1.default.extend(/^and a valid email address$/i, function (val) {
            return /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/i.test(val);
        });
    };
    return Validation;
}());
exports.default = Validation;
//# sourceMappingURL=validation.js.map